#ifndef _ASSIGN_INV_MULT_EOPREC_WD_RAS_MIC_H
#define _ASSIGN_INV_MULT_EOPREC_WD_RAS_MIC_H

//#undef _RAS_CHECK

#include "omp_sched.h"

void copy_boundary_ras_wqf_eo(mic_ras_wqf_eo *qe)
{
// Translate from Fortran
  const int lbx = 1-NDEPTHX;
  const int lby = 1-NDEPTHY;
  const int lbz = 1-NDEPTHZ;
  const int lbt = 1;

#if _NDIMZ != 1
  #pragma omp parallel for collapse(3)
  for (int ix = 1; ix <= NX; ++ix)
  for (int iy = 1; iy <= NY; ++iy)
  for (int itht = 1; itht <= NTHT; ++itht)
  for (int iz = 0; iz <= NDEPTHZ-1; ++iz)
  {
    int ibuff = 2*COL*(itht-1 + NTHT*(iz + NDEPTHZ*(iy-1 + NY*(ix-1))));
    int isite_ras = get_ras_site(itht-lbt,NZ-NDEPTHZ+1+iz-lbz,iy-lby,ix-lbx);
    szbuff_up[ibuff+0] = (*qe).s[isite_ras].y[0];
    szbuff_up[ibuff+1] = (*qe).s[isite_ras].y[1];
    szbuff_up[ibuff+2] = (*qe).s[isite_ras].y[2];
    szbuff_up[ibuff+3] = (*qe).s[isite_ras].y[3];
    szbuff_up[ibuff+4] = (*qe).s[isite_ras].y[4];
    szbuff_up[ibuff+5] = (*qe).s[isite_ras].y[5];
    isite_ras = get_ras_site(itht-lbt,1+iz-lbz,iy-lby,ix-lbx);
    szbuff_dn[ibuff+0] = (*qe).s[isite_ras].y[0];
    szbuff_dn[ibuff+1] = (*qe).s[isite_ras].y[1];
    szbuff_dn[ibuff+2] = (*qe).s[isite_ras].y[2];
    szbuff_dn[ibuff+3] = (*qe).s[isite_ras].y[3];
    szbuff_dn[ibuff+4] = (*qe).s[isite_ras].y[4];
    szbuff_dn[ibuff+5] = (*qe).s[isite_ras].y[5];
  }
  mic_combuf_sendrecv(bsize_z,          // both buffers same size
    bszbuff_up, mic_nodeid_z_up,        // send up to up node
    brzbuff_up, mic_nodeid_z_dn);       // receive up from down node
  mic_combuf_sendrecv(bsize_z,          // both buffers same size
    bszbuff_dn, mic_nodeid_z_dn,        // send down to down node
    brzbuff_dn, mic_nodeid_z_up);       // receive down from up node

  #pragma omp parallel for collapse(3)
  for (int ix = 1; ix <= NX; ++ix)
  for (int iy = 1; iy <= NY; ++iy)
  for (int itht = 1; itht <= NTHT; ++itht)
  for (int iz = 0; iz <= NDEPTHZ-1; ++iz)
  {
    int ibuff = 2*COL*(itht-1 + NTHT*(iz + NDEPTHZ*(iy-1 + NY*(ix-1))));
    int isite_ras = get_ras_site(itht-lbt,1-NDEPTHZ+iz-lbz,iy-lby,ix-lbx);
    (*qe).s[isite_ras].y[0] = rzbuff_up[ibuff+0];
    (*qe).s[isite_ras].y[1] = rzbuff_up[ibuff+1];
    (*qe).s[isite_ras].y[2] = rzbuff_up[ibuff+2];
    (*qe).s[isite_ras].y[3] = rzbuff_up[ibuff+3];
    (*qe).s[isite_ras].y[4] = rzbuff_up[ibuff+4];
    (*qe).s[isite_ras].y[5] = rzbuff_up[ibuff+5];
    isite_ras = get_ras_site(itht-lbt,NZ+1+iz-lbz,iy-lby,ix-lbx);
    (*qe).s[isite_ras].y[0] = rzbuff_dn[ibuff+0];
    (*qe).s[isite_ras].y[1] = rzbuff_dn[ibuff+1];
    (*qe).s[isite_ras].y[2] = rzbuff_dn[ibuff+2];
    (*qe).s[isite_ras].y[3] = rzbuff_dn[ibuff+3];
    (*qe).s[isite_ras].y[4] = rzbuff_dn[ibuff+4];
    (*qe).s[isite_ras].y[5] = rzbuff_dn[ibuff+5];
  }
#endif
  
#if _NDIMY != 1
  #pragma omp parallel for collapse(3)
  for (int ix = 1; ix <= NX; ++ix)
  for (int iz = 1-NDEPTHZ; iz <= NZ+NDEPTHZ; ++iz)
  for (int itht = 1; itht <= NTHT; ++itht)
  for (int iy = 0; iy <= NDEPTHY-1; ++iy)
  {
    int ibuff = 2*COL*(itht-1 + NTHT*(iz-1+NDEPTHZ + (NZ+NDEPTHZ*2)*(iy + NDEPTHY*(ix-1))));
    int isite_ras = get_ras_site(itht-lbt,iz-lbz,NY-NDEPTHY+1+iy-lby,ix-lbx);
    sybuff_up[ibuff+0] = (*qe).s[isite_ras].y[0];
    sybuff_up[ibuff+1] = (*qe).s[isite_ras].y[1];
    sybuff_up[ibuff+2] = (*qe).s[isite_ras].y[2];
    sybuff_up[ibuff+3] = (*qe).s[isite_ras].y[3];
    sybuff_up[ibuff+4] = (*qe).s[isite_ras].y[4];
    sybuff_up[ibuff+5] = (*qe).s[isite_ras].y[5];
    isite_ras = get_ras_site(itht-lbt,iz-lbz,1+iy-lby,ix-lbx);
    sybuff_dn[ibuff+0] = (*qe).s[isite_ras].y[0];
    sybuff_dn[ibuff+1] = (*qe).s[isite_ras].y[1];
    sybuff_dn[ibuff+2] = (*qe).s[isite_ras].y[2];
    sybuff_dn[ibuff+3] = (*qe).s[isite_ras].y[3];
    sybuff_dn[ibuff+4] = (*qe).s[isite_ras].y[4];
    sybuff_dn[ibuff+5] = (*qe).s[isite_ras].y[5];
  }

  mic_combuf_sendrecv(bsize_y,          // both buffers same size
    bsybuff_up, mic_nodeid_y_up,        // send up to up node
    brybuff_up, mic_nodeid_y_dn);       // receive up from down node
  mic_combuf_sendrecv(bsize_y,          // both buffers same size
    bsybuff_dn, mic_nodeid_y_dn,        // send down to down node
    brybuff_dn, mic_nodeid_y_up);       // receive down from up node

  #pragma omp parallel for collapse(3)
  for (int ix = 1; ix <= NX; ++ix)
  for (int iz = 1-NDEPTHZ; iz <= NZ+NDEPTHZ; ++iz)
  for (int itht = 1; itht <= NTHT; ++itht)
  for (int iy = 0; iy <= NDEPTHY-1; ++iy)
  {
    int ibuff = 2*COL*(itht-1 + NTHT*(iz-1+NDEPTHZ + (NZ+NDEPTHZ*2)*(iy + NDEPTHY*(ix-1))));
    int isite_ras = get_ras_site(itht-lbt,iz-lbz,1-NDEPTHY+iy-lby,ix-lbx);
    (*qe).s[isite_ras].y[0] = rybuff_up[ibuff+0];
    (*qe).s[isite_ras].y[1] = rybuff_up[ibuff+1];
    (*qe).s[isite_ras].y[2] = rybuff_up[ibuff+2];
    (*qe).s[isite_ras].y[3] = rybuff_up[ibuff+3];
    (*qe).s[isite_ras].y[4] = rybuff_up[ibuff+4];
    (*qe).s[isite_ras].y[5] = rybuff_up[ibuff+5];
    isite_ras = get_ras_site(itht-lbt,iz-lbz,NY+1+iy-lby,ix-lbx);
    (*qe).s[isite_ras].y[0] = rybuff_dn[ibuff+0];
    (*qe).s[isite_ras].y[1] = rybuff_dn[ibuff+1];
    (*qe).s[isite_ras].y[2] = rybuff_dn[ibuff+2];
    (*qe).s[isite_ras].y[3] = rybuff_dn[ibuff+3];
    (*qe).s[isite_ras].y[4] = rybuff_dn[ibuff+4];
    (*qe).s[isite_ras].y[5] = rybuff_dn[ibuff+5];
  }
#endif

#if _NDIMX != 1
  #pragma omp parallel for collapse(3)
  for (int iy = 1-NDEPTHY; iy <= NY+NDEPTHY; ++iy)
  for (int iz = 1-NDEPTHZ; iz <= NZ+NDEPTHZ; ++iz)
  for (int itht = 1; itht <= NTHT; ++itht)
  for (int ix = 0; ix <= NDEPTHX-1; ++ix)
  {
    int ibuff = 2*COL*(itht-1 + NTHT*(iz-1+NDEPTHZ + (NZ+NDEPTHZ*2)*(iy-1+NDEPTHY + (NY+NDEPTHY*2)*ix)));
    int isite_ras = get_ras_site(itht-lbt,iz-lbz,iy-lby,NX-NDEPTHX+1+ix-lbx);
    sxbuff_up[ibuff+0] = (*qe).s[isite_ras].y[0];
    sxbuff_up[ibuff+1] = (*qe).s[isite_ras].y[1];
    sxbuff_up[ibuff+2] = (*qe).s[isite_ras].y[2];
    sxbuff_up[ibuff+3] = (*qe).s[isite_ras].y[3];
    sxbuff_up[ibuff+4] = (*qe).s[isite_ras].y[4];
    sxbuff_up[ibuff+5] = (*qe).s[isite_ras].y[5];
    isite_ras = get_ras_site(itht-lbt,iz-lbz,iy-lby,1+ix-lbx);
    sxbuff_dn[ibuff+0] = (*qe).s[isite_ras].y[0];
    sxbuff_dn[ibuff+1] = (*qe).s[isite_ras].y[1];
    sxbuff_dn[ibuff+2] = (*qe).s[isite_ras].y[2];
    sxbuff_dn[ibuff+3] = (*qe).s[isite_ras].y[3];
    sxbuff_dn[ibuff+4] = (*qe).s[isite_ras].y[4];
    sxbuff_dn[ibuff+5] = (*qe).s[isite_ras].y[5];
  }
  mic_combuf_sendrecv(bsize_x,          // both buffers same size
    bsxbuff_up, mic_nodeid_x_up,        // send up to up node
    brxbuff_up, mic_nodeid_x_dn);       // receive up from down node
  mic_combuf_sendrecv(bsize_x,          // both buffers same size
    bsxbuff_dn, mic_nodeid_x_dn,        // send down to down node
    brxbuff_dn, mic_nodeid_x_up);       // receive down from up node
  #pragma omp parallel for collapse(3)
  for (int iy = 1-NDEPTHY; iy <= NY+NDEPTHY; ++iy)
  for (int iz = 1-NDEPTHZ; iz <= NZ+NDEPTHZ; ++iz)
  for (int itht = 1; itht <= NTHT; ++itht)
  for (int ix = 0; ix <= NDEPTHX-1; ++ix)
  {
    int ibuff = 2*COL*(itht-1 + NTHT*(iz-1+NDEPTHZ + (NZ+NDEPTHZ*2)*(iy-1+NDEPTHY + (NY+NDEPTHY*2)*ix)));
    int isite_ras = get_ras_site(itht-lbt,iz-lbz,iy-lby,1-NDEPTHX+ix-lbx);
    (*qe).s[isite_ras].y[0] = rxbuff_up[ibuff+0];
    (*qe).s[isite_ras].y[1] = rxbuff_up[ibuff+1];
    (*qe).s[isite_ras].y[2] = rxbuff_up[ibuff+2];
    (*qe).s[isite_ras].y[3] = rxbuff_up[ibuff+3];
    (*qe).s[isite_ras].y[4] = rxbuff_up[ibuff+4];
    (*qe).s[isite_ras].y[5] = rxbuff_up[ibuff+5];
    isite_ras = get_ras_site(itht-lbt,iz-lbz,iy-lby,NX+1+ix-lbx);
    (*qe).s[isite_ras].y[0] = rxbuff_dn[ibuff+0];
    (*qe).s[isite_ras].y[1] = rxbuff_dn[ibuff+1];
    (*qe).s[isite_ras].y[2] = rxbuff_dn[ibuff+2];
    (*qe).s[isite_ras].y[3] = rxbuff_dn[ibuff+3];
    (*qe).s[isite_ras].y[4] = rxbuff_dn[ibuff+4];
    (*qe).s[isite_ras].y[5] = rxbuff_dn[ibuff+5];
  }
#endif
}


///////////////////////////////////////////////////////////////
//
// linear operations for RAS domain extended fermion fields
//
///////////////////////////////////////////////////////////////
static inline void 
dump_y(const mic_ras_wqf_eo *qe) {

  for (int ix = 0; ix < NX; ++ix) {
  for (int iy = 0; iy < NY; ++iy) {
  for (int iz = 0; iz < NZ; ++iz) {
    for (int itht = 0; itht < NTHT; ++itht) {
      int isite_ras = get_ras_site(itht,NDEPTHZ+iz,NDEPTHY+iy,NDEPTHX+ix);
      float _ALIG_PRE_ a11[16] _ALIG_PST_;
      float _ALIG_PRE_ a21[16] _ALIG_PST_;
      float _ALIG_PRE_ a31[16] _ALIG_PST_;
      float _ALIG_PRE_ a12[16] _ALIG_PST_;
      float _ALIG_PRE_ a22[16] _ALIG_PST_;
      float _ALIG_PRE_ a32[16] _ALIG_PST_;

      _my_store_ps(a11,(*qe).s[isite_ras].y[0]);
      _my_store_ps(a21,(*qe).s[isite_ras].y[1]);
      _my_store_ps(a31,(*qe).s[isite_ras].y[2]);
      _my_store_ps(a12,(*qe).s[isite_ras].y[3]);
      _my_store_ps(a22,(*qe).s[isite_ras].y[4]);
      _my_store_ps(a32,(*qe).s[isite_ras].y[5]);

      for (int ivec = 0; ivec < VLEN; ++ivec) {
        int ith = 1+ivec + VLEN*itht;
        printf("nodeid %3d nodeidxyz %3d%3d%3d: %4d%4d%4d%4d 1 1 %14.6e %14.6e\n", _nodeid_,mic_nodeid_x,mic_nodeid_y,mic_nodeid_z,ith,iz+1,iy+1,ix+1,a11[ivec       ], a11[ivec+2*VLEN]);
        printf("nodeid %3d nodeidxyz %3d%3d%3d: %4d%4d%4d%4d 2 1 %14.6e %14.6e\n", _nodeid_,mic_nodeid_x,mic_nodeid_y,mic_nodeid_z,ith,iz+1,iy+1,ix+1,a21[ivec       ], a21[ivec+2*VLEN]);
        printf("nodeid %3d nodeidxyz %3d%3d%3d: %4d%4d%4d%4d 3 1 %14.6e %14.6e\n", _nodeid_,mic_nodeid_x,mic_nodeid_y,mic_nodeid_z,ith,iz+1,iy+1,ix+1,a31[ivec       ], a31[ivec+2*VLEN]);
        printf("nodeid %3d nodeidxyz %3d%3d%3d: %4d%4d%4d%4d 1 2 %14.6e %14.6e\n", _nodeid_,mic_nodeid_x,mic_nodeid_y,mic_nodeid_z,ith,iz+1,iy+1,ix+1,a11[ivec+  VLEN], a11[ivec+3*VLEN]);
        printf("nodeid %3d nodeidxyz %3d%3d%3d: %4d%4d%4d%4d 2 2 %14.6e %14.6e\n", _nodeid_,mic_nodeid_x,mic_nodeid_y,mic_nodeid_z,ith,iz+1,iy+1,ix+1,a21[ivec+  VLEN], a21[ivec+3*VLEN]);
        printf("nodeid %3d nodeidxyz %3d%3d%3d: %4d%4d%4d%4d 3 2 %14.6e %14.6e\n", _nodeid_,mic_nodeid_x,mic_nodeid_y,mic_nodeid_z,ith,iz+1,iy+1,ix+1,a31[ivec+  VLEN], a31[ivec+3*VLEN]);
        printf("nodeid %3d nodeidxyz %3d%3d%3d: %4d%4d%4d%4d 1 3 %14.6e %14.6e\n", _nodeid_,mic_nodeid_x,mic_nodeid_y,mic_nodeid_z,ith,iz+1,iy+1,ix+1,a12[ivec       ], a12[ivec+2*VLEN]);
        printf("nodeid %3d nodeidxyz %3d%3d%3d: %4d%4d%4d%4d 2 3 %14.6e %14.6e\n", _nodeid_,mic_nodeid_x,mic_nodeid_y,mic_nodeid_z,ith,iz+1,iy+1,ix+1,a22[ivec       ], a22[ivec+2*VLEN]);
        printf("nodeid %3d nodeidxyz %3d%3d%3d: %4d%4d%4d%4d 3 3 %14.6e %14.6e\n", _nodeid_,mic_nodeid_x,mic_nodeid_y,mic_nodeid_z,ith,iz+1,iy+1,ix+1,a32[ivec       ], a32[ivec+2*VLEN]);
        printf("nodeid %3d nodeidxyz %3d%3d%3d: %4d%4d%4d%4d 1 4 %14.6e %14.6e\n", _nodeid_,mic_nodeid_x,mic_nodeid_y,mic_nodeid_z,ith,iz+1,iy+1,ix+1,a12[ivec+  VLEN], a12[ivec+3*VLEN]);
        printf("nodeid %3d nodeidxyz %3d%3d%3d: %4d%4d%4d%4d 2 4 %14.6e %14.6e\n", _nodeid_,mic_nodeid_x,mic_nodeid_y,mic_nodeid_z,ith,iz+1,iy+1,ix+1,a22[ivec+  VLEN], a22[ivec+3*VLEN]);
        printf("nodeid %3d nodeidxyz %3d%3d%3d: %4d%4d%4d%4d 3 4 %14.6e %14.6e\n", _nodeid_,mic_nodeid_x,mic_nodeid_y,mic_nodeid_z,ith,iz+1,iy+1,ix+1,a32[ivec+  VLEN], a32[ivec+3*VLEN]);
      }

    }
  }
  }
  }

}

static inline void 
assign(mic_ras_wqf_eo *qe, const mic_wqf_eo *ve) {
//
//  assignment with overlap region extension (prolongation)
//  qe = ve
//
  (*qe).ieo  = (*ve).ieo;
  //prcorners("in assign", ve);
  Percore cores[maxCores];
#pragma omp parallel
{
  int nblocks = NX * NY * NZ;
  Sched sch(nblocks, cores);
  #pragma omp barrier
  int block;
  while ((block = sch.nextiter()) != -1)
  {
    int ix =  block / (NY*NZ);
    int rem = block % (NY*NZ);
    int iy  = rem   /  NZ;
    int iz  = rem   %  NZ;

    for (int itht = sch.myht; itht < NTHT; itht+=nHT) {
      int isite     =     get_site(itht,iz,iy,ix);
      int isite_ras = get_ras_site(itht,NDEPTHZ+iz,NDEPTHY+iy,NDEPTHX+ix);
      _my_ngostore_ps(&(*qe).s[isite_ras].y[0], (*ve).s[isite].y[0]);
      _my_ngostore_ps(&(*qe).s[isite_ras].y[1], (*ve).s[isite].y[1]);
      _my_ngostore_ps(&(*qe).s[isite_ras].y[2], (*ve).s[isite].y[2]);
      _my_ngostore_ps(&(*qe).s[isite_ras].y[3], (*ve).s[isite].y[3]);
      _my_ngostore_ps(&(*qe).s[isite_ras].y[4], (*ve).s[isite].y[4]);
      _my_ngostore_ps(&(*qe).s[isite_ras].y[5], (*ve).s[isite].y[5]);
    }
  }
  // force store completion
}


  //prcorners_ras("copy before", qe);
  startTimer(solver_timer.ras_ycopy_timer);
  copy_boundary_ras_wqf_eo(qe);
  stopTimer(solver_timer.ras_ycopy_timer);
  //prcorners_ras("copy after", qe);
  //prshadow("shadow copy after", qe);

#ifdef _TIMING_

#if _NDIMZ != 1
  solver_timer.ras_ycopy_dsize += VLEN*COL*SPIN*NDEPTHZ*NTHT*NX*NY*8;
#endif
#if _NDIMY != 1
  solver_timer.ras_ycopy_dsize += VLEN*COL*SPIN*NDEPTHY*NTHT*NZ*(2*NDEPTHZ + NZ)*8;
#endif
#if _NDIMX != 1
  solver_timer.ras_ycopy_dsize += VLEN*COL*SPIN*NDEPTHX*NTHT*(2*NDEPTHY + NY)*(2*NDEPTHZ + NZ)*8;
#endif
  solver_timer.ras_ycopy_count++;

#endif

}

static inline void 
assign(mic_wqf_eo *qe, const mic_ras_wqf_eo *ve) {
//
//  assignment only physical region (restriction)
//  qe = ve
//
  (*qe).ieo  = (*ve).ieo;
  
  Percore cores[maxCores];
#pragma omp parallel
{
  int nblocks = NX * NY * NZ;
  Sched sch(nblocks, cores);
  #pragma omp barrier
  int block;
  while ((block = sch.nextiter()) != -1)
  {
    int ix =  block / (NY*NZ);
    int rem = block % (NY*NZ);
    int iy  = rem   /  NZ;
    int iz  = rem   %  NZ;

    for (int itht = sch.myht; itht < NTHT; itht+=nHT) {
      int isite     =     get_site(itht,iz,iy,ix);
      int isite_ras = get_ras_site(itht,NDEPTHZ+iz,NDEPTHY+iy,NDEPTHX+ix);
      _my_ngostore_ps(&(*qe).s[isite].y[0], (*ve).s[isite_ras].y[0]);
      _my_ngostore_ps(&(*qe).s[isite].y[1], (*ve).s[isite_ras].y[1]);
      _my_ngostore_ps(&(*qe).s[isite].y[2], (*ve).s[isite_ras].y[2]);
      _my_ngostore_ps(&(*qe).s[isite].y[3], (*ve).s[isite_ras].y[3]);
      _my_ngostore_ps(&(*qe).s[isite].y[4], (*ve).s[isite_ras].y[4]);
      _my_ngostore_ps(&(*qe).s[isite].y[5], (*ve).s[isite_ras].y[5]);
    }
  }
}

}

////////////////////////////////////////////////////////////////////////////

static void 
assign_inv_mult_eoprec_wd_eo_ras_mr(const float      *kappa,
                                          mic_wqf_eo *restrict dye,
                                    const mic_wqf_eo *restrict ye) {
//
// Multiply RAS overlapped domain inversion for       v
// even/odd-site preconditioned Dirac operator : yd = Dee y,
//       v
// where Dee = 1 - kappa^2 Fee Meo Foo Moe
//
//  dye = Mras ye = (sum_{domain} (Dee_domain)^-1 ) ye
//
//  kappa : hopping parameter
//    dye : even/odd site fermion (output)
//     ye : even/odd site fermion (input)
//
//      u : gauge link with overlapped ghost sites
// fclinv : inverse clover term with overlapped ghost sites
//

  mic_ras_wqf_eo *Myo, *rdye, *rye;

  startTimer(solver_timer.binv_timer);

  int ieo  = (*ye).ieo;
  int ioe  = 1-ieo;

  (*dye).ieo  = ieo;

   Myo = ras_wqf_tmp.push();
   rye = ras_wqf_tmp.push();
  rdye = ras_wqf_tmp.push();

#ifdef _TIMING_
  double rasmultfp0 = solver_timer.ras_mult_flop_count;
#endif

  //
  // copy with overlapped domain (prolongation)
  //
  //prcorners("ye before assign", ye);
  assign(rye,ye);
  //prcorners_ras("rye after assign", rye);

  // rdye = rye
  assign(rdye,rye);


  for (unsigned int iter = 0; iter < _NMR; ++iter) {

    //
    //  Myo = Moe rdye;  (acts on extended region)
    //
#ifdef _CLOVER
    assign_mult_hop_eo_ras_mic(Myo,rdye,&((*ras_u).eo[ioe]),&((*ras_u).eo[ieo]),&((*ras_fclinv).eo[ioe]));
#else
    assign_mult_hop_eo_ras_mic(Myo,rdye,&((*ras_u).eo[ioe]),&((*ras_u).eo[ieo]));
#endif
  //printf("ioe: %d ieo: %d\n", ioe, ieo);
  //prcorners_ras("Myo after assign", Myo);

    //
    //  rdye = Meo Myo = (Meo Moe) rdye;  (acts on extended region)
    //
#ifdef _CLOVER
    assign_mult_hop_eo_ras_mic(rdye,Myo,&((*ras_u).eo[ieo]),&((*ras_u).eo[ioe]),&((*ras_fclinv).eo[ieo]));
#else
    assign_mult_hop_eo_ras_mic(rdye,Myo,&((*ras_u).eo[ieo]),&((*ras_u).eo[ioe]));
#endif
  //prcorners_ras("rdye after assign", rdye);

    //
    //  rdye = rye + kappa^2 rdye;  (acts on extended region)
    //
    float _ALIG_PRE_ kappa2 _ALIG_PST_;
    kappa2  = (*kappa)*(*kappa);
    accum_mult_add(rdye,&kappa2,rye);

#ifdef _TIMING_
    solver_timer.solv_flop_count += (QACCUM_RMULT_ADD)*NTH*NEZ*NEY*NEX;
#endif

  }

  //
  // copy without overlapped domain (restriction)
  //
  assign(dye,rdye);

  ras_wqf_tmp.pop(3);


#ifdef _TIMING_
  solver_timer.solv_flop_count += (solver_timer.ras_mult_flop_count-rasmultfp0);
#endif

  stopTimer(solver_timer.binv_timer);

}

extern "C" void 
#ifdef _CLOVER
assign_inv_mult_eoprec_wd_ras_mic(const float       *kappa,
                                        mic_wqf_eo  *restrict dye,
                                  const mic_wqf_eo  *restrict  ye,
                                  const mic_gvf_soa     *u,
                                  const mic_clvf    *fclinv) {
#else
assign_inv_mult_eoprec_wd_ras_mic(const float       *kappa,
                                        mic_wqf_eo  *restrict dye,
                                  const mic_wqf_eo  *restrict  ye,
                                  const mic_gvf_soa     *u) {
#endif
//
// multiply approximate inverse of the even/odd preconditioned Dirac operator
// with RAS iteration.
//          v
//    dye = Dee \ ye
//
//  kappa : hopping parameter
//    dye : even/odd site fermion field
//     ye : even/odd site fermion field
//      u : gauge link field
// fclinv : inverse clover term field
//

  mic_wqf_eo *qe, *ve, *re;

  startTimer(solver_timer.ras_prec_timer);

  int ieo  = (*ye).ieo;

  (*dye).ieo  = ieo;

  qe = wqf_tmp.push();
  ve = wqf_tmp.push();
  re = wqf_tmp.push();

  assign(dye,ye);
  assign( ve,ye);
  assign( re,ye);

  //prcorners("dye enter", dye);
  //prcorners("ve enter", ve);
  //prcorners("re enter", re);

  for (unsigned int iter = 0; iter < _NRAS; ++iter ) {

    //
    //  qe = Dee ve
    //
#ifdef _CLOVER
    assign_mult_eoprec_wd_eo_mic(kappa,qe,ve,u,fclinv);
#else
    assign_mult_eoprec_wd_eo_mic(kappa,qe,ve,u);
#endif
  //prcorners("qe after assign", qe);

    //
    //  re = re - qe
    //
    accum_sub(re,qe);
#ifdef _TIMING_
    solver_timer.solv_flop_count += QACCUM_SUB*NTH*NZ*NY*NX;
#endif

#ifdef _RAS_CHECK
    { float res = abs2(re); if (_nodeid_ == 0) printf("RR: %3d ras_res=%14.6e\n",iter,sqrtf(res)); }
#endif

    //
    //  ve = Mras re;  (apply overlapped domain inversion)
    //
  //prcorners("ve before assign_inv", ve);
  //prcorners("re before assign_inv", re);
    assign_inv_mult_eoprec_wd_eo_ras_mr(kappa,ve,re);
  //prcorners("ve after assign_inv", ve);

    //
    // dye = dye + ve
    //
    accum_add(dye,ve);
#ifdef _TIMING_
    solver_timer.solv_flop_count += QACCUM_ADD*NTH*NZ*NY*NX;
#endif

  }

  wqf_tmp.pop(3);

  stopTimer(solver_timer.ras_prec_timer);

}

#endif
