#ifndef _MIC_CONFIG_H
#define _MIC_CONFIG_H

!------------------------------------------------------------------
! if _DEBUG_  is defined, the residual history will be printed out.
! if _TIMING_ is defined, the solver flops performance will be measured.
!------------------------------------------------------------------
!#define _DEBUG_
#define _TIMING_

!----------------------------
! choice of preconditioner
! Only RAS is available
!----------------------------
#define _USE_RAS

!------------------------------------------------------------------
! RAS (Restricted overlapping Additiv Shwarz preconditioner)
! MPI Parallel only
!  _NRAS   : number of RAS iteration 
!  _NMR    : domain MR iteration
!  _NDEPTH : depth of domain overlapping region
!------------------------------------------------------------------
#ifdef _USE_RAS
#define _NRAS   (8)
#define _NMR    (2)
#define _NDEPTH (1)
#endif


!------------------------------------------------------------------
! Reserved paramters for
! SAP (Shwarz Alternating Procedure preconditioner)
!  _NSAP    : number of SAP iteration
!  _NMR_SAP : domain MR iteration 
!------------------------------------------------------------------
!#ifdef _USE_SAP
!#define _NSAP     (0)
!#define _NMR_SAP  (0)
!#endif


!-----------------------------------------
! RAS preconditioner is prefarable
!-----------------------------------------
#if defined(_USE_RAS) && defined(_USE_SAP)
#undef _USE_SAP
#endif

#ifndef _USE_RAS
#define _NRAS   (0)
#define _NMR    (0)
#define _NDEPTH (0)
#endif

#ifndef _USE_SAP
#define _NSAP     (0)
#define _NMR_SAP  (0)
#endif

#ifdef _singlePU
#endif

#endif
