#ifndef _MIC_SU3_BASIC_ALGEBRA_H
#define _MIC_SU3_BASIC_ALGEBRA_H

#if __MIC__ == 1

#warning MIC is used.

#define MASK_F00F  0xF00F
#define MASK_F0F0  0xF0F0
#define MASK_0FF0  0x0FF0
#define MASK_0F0F  0x0F0F
#define MASK_00FF  0x00FF
#define MASK_FF00  0xFF00


// load u
#define __mic_su3_load_u(_u_,_uptr_) {\
  _u_ ## 1 = _mm512_load_ps((char*)&((*_uptr_).u[0]));\
  _u_ ## 2 = _mm512_load_ps((char*)&((*_uptr_).u[1]));\
  _u_ ## 3 = _mm512_load_ps((char*)&((*_uptr_).u[2]));\
}

/////////////////////
// T-direction
/////////////////////
#define __mic_mult_proj_pre_forw_t(_hy_,_yptr_) {\
  _hy_ ## 1 = _mm512_load_ps((char*)&((*_yptr_).y[3]));\
  _hy_ ## 2 = _mm512_load_ps((char*)&((*_yptr_).y[4]));\
  _hy_ ## 3 = _mm512_load_ps((char*)&((*_yptr_).y[5]));\
}

#define __mic_mult_shift_forw_t(_hy0_,_hy1_) {\
  _hy0_ ## 1 = (__m512)_mm512_shuffle_epi32((__m512i)_hy0_ ## 1,_MM_PERM_ADCB);\
  _hy0_ ## 2 = (__m512)_mm512_shuffle_epi32((__m512i)_hy0_ ## 2,_MM_PERM_ADCB);\
  _hy0_ ## 3 = (__m512)_mm512_shuffle_epi32((__m512i)_hy0_ ## 3,_MM_PERM_ADCB);\
  _hy1_ ## 1 = (__m512)_mm512_shuffle_epi32((__m512i)_hy1_ ## 1,_MM_PERM_ADCB);\
  _hy1_ ## 2 = (__m512)_mm512_shuffle_epi32((__m512i)_hy1_ ## 2,_MM_PERM_ADCB);\
  _hy1_ ## 3 = (__m512)_mm512_shuffle_epi32((__m512i)_hy1_ ## 3,_MM_PERM_ADCB);\
  _hy0_ ## 1 = _mm512_mask_blend_ps(0x8888,_hy0_ ## 1,_hy1_ ## 1);\
  _hy0_ ## 2 = _mm512_mask_blend_ps(0x8888,_hy0_ ## 2,_hy1_ ## 2);\
  _hy0_ ## 3 = _mm512_mask_blend_ps(0x8888,_hy0_ ## 3,_hy1_ ## 3);\
}

#define __mic_mult_proj_post_forw_t(_yy_,_uhy_) {\
  _yy_ ## 4 = _mm512_add_ps(_uhy_ ## 1,_uhy_ ## 1);\
  _yy_ ## 5 = _mm512_add_ps(_uhy_ ## 2,_uhy_ ## 2);\
  _yy_ ## 6 = _mm512_add_ps(_uhy_ ## 3,_uhy_ ## 3);\
}

#define __mic_mult_proj_pre_back_t(_hy_,_yptr_) {\
  _hy_ ## 1 = _mm512_load_ps((char*)&((*_yptr_).y[0]));\
  _hy_ ## 2 = _mm512_load_ps((char*)&((*_yptr_).y[1]));\
  _hy_ ## 3 = _mm512_load_ps((char*)&((*_yptr_).y[2]));\
}

#define __mic_mult_shift_back_t(_hy0_,_hy1_) {\
  _hy0_ ## 1 = (__m512)_mm512_shuffle_epi32((__m512i)_hy0_ ## 1,_MM_PERM_CBAD);\
  _hy0_ ## 2 = (__m512)_mm512_shuffle_epi32((__m512i)_hy0_ ## 2,_MM_PERM_CBAD);\
  _hy0_ ## 3 = (__m512)_mm512_shuffle_epi32((__m512i)_hy0_ ## 3,_MM_PERM_CBAD);\
  _hy1_ ## 1 = (__m512)_mm512_shuffle_epi32((__m512i)_hy1_ ## 1,_MM_PERM_CBAD);\
  _hy1_ ## 2 = (__m512)_mm512_shuffle_epi32((__m512i)_hy1_ ## 2,_MM_PERM_CBAD);\
  _hy1_ ## 3 = (__m512)_mm512_shuffle_epi32((__m512i)_hy1_ ## 3,_MM_PERM_CBAD);\
  _hy0_ ## 1 = _mm512_mask_blend_ps(0x1111,_hy0_ ## 1,_hy1_ ## 1);\
  _hy0_ ## 2 = _mm512_mask_blend_ps(0x1111,_hy0_ ## 2,_hy1_ ## 2);\
  _hy0_ ## 3 = _mm512_mask_blend_ps(0x1111,_hy0_ ## 3,_hy1_ ## 3);\
}

#define __mic_mult_proj_post_back_t(_yy_,_uhy_) {\
  _yy_ ## 1 = _mm512_add_ps(_uhy_ ## 1,_uhy_ ## 1);\
  _yy_ ## 2 = _mm512_add_ps(_uhy_ ## 2,_uhy_ ## 2);\
  _yy_ ## 3 = _mm512_add_ps(_uhy_ ## 3,_uhy_ ## 3);\
}

/////////////////////
// Z-direction
/////////////////////
#define __mic_mult_proj_pre_forw_z(_hy_,_yptr_) {\
  register __m512  neg = _mm512_set1_ps(-0.0f);\
  register __m512  _hy_ ## 4, _hy_ ## 5, _hy_ ## 6;\
  _hy_ ## 1 = _mm512_load_ps((char*)&((*_yptr_).y[0]));\
  _hy_ ## 2 = _mm512_load_ps((char*)&((*_yptr_).y[1]));\
  _hy_ ## 3 = _mm512_load_ps((char*)&((*_yptr_).y[2]));\
  _hy_ ## 4 = _mm512_load_ps((char*)&((*_yptr_).y[3]));\
  _hy_ ## 5 = _mm512_load_ps((char*)&((*_yptr_).y[4]));\
  _hy_ ## 6 = _mm512_load_ps((char*)&((*_yptr_).y[5]));\
  _hy_ ## 4 = (__m512)_mm512_permute4f128_epi32((__m512i)_hy_ ## 4,_MM_PERM_BADC); /* _hy_ ## 4 = (y14r, y13r, y14i, y13i) */\
  _hy_ ## 5 = (__m512)_mm512_permute4f128_epi32((__m512i)_hy_ ## 5,_MM_PERM_BADC); /* _hy_ ## 5 = (y24r, y23r, y24i, y23i) */\
  _hy_ ## 6 = (__m512)_mm512_permute4f128_epi32((__m512i)_hy_ ## 6,_MM_PERM_BADC); /* _hy_ ## 6 = (y34r, y33r, y34i, y33i) */\
  _hy_ ## 4 = (__m512)_mm512_mask_xor_epi32((__m512i)_hy_ ## 4,0xF00F,(__m512i)_hy_ ## 4,(__m512i)neg); /* _hy_ ## 4 = (-y14r, y13r, y14i,-y13i) */\
  _hy_ ## 5 = (__m512)_mm512_mask_xor_epi32((__m512i)_hy_ ## 5,0xF00F,(__m512i)_hy_ ## 5,(__m512i)neg); /* _hy_ ## 5 = (-y24r, y23r, y24i,-y23i) */\
  _hy_ ## 6 = (__m512)_mm512_mask_xor_epi32((__m512i)_hy_ ## 6,0xF00F,(__m512i)_hy_ ## 6,(__m512i)neg); /* _hy_ ## 6 = (-y34r, y33r, y34i,-y33i) */\
  _hy_ ## 1 = _mm512_add_ps(_hy_ ## 1,_hy_ ## 4);\
  _hy_ ## 2 = _mm512_add_ps(_hy_ ## 2,_hy_ ## 5);\
  _hy_ ## 3 = _mm512_add_ps(_hy_ ## 3,_hy_ ## 6);\
}

#define __mic_mult_proj_post_forw_z(_yy_,_uhy_) {\
  register __m512  neg = _mm512_set1_ps(-0.0f);\
  register __m512  _uhy_ ## 4, _uhy_ ## 5, _uhy_ ## 6;\
  _uhy_ ## 4 = (__m512)_mm512_permute4f128_epi32((__m512i)_uhy_ ## 1,_MM_PERM_BADC);\
  _uhy_ ## 5 = (__m512)_mm512_permute4f128_epi32((__m512i)_uhy_ ## 2,_MM_PERM_BADC);\
  _uhy_ ## 6 = (__m512)_mm512_permute4f128_epi32((__m512i)_uhy_ ## 3,_MM_PERM_BADC);\
  _uhy_ ## 4 = (__m512)_mm512_mask_xor_epi32((__m512i)_uhy_ ## 4,0x0FF0,(__m512i)_uhy_ ## 4,(__m512i)neg);\
  _uhy_ ## 5 = (__m512)_mm512_mask_xor_epi32((__m512i)_uhy_ ## 5,0x0FF0,(__m512i)_uhy_ ## 5,(__m512i)neg);\
  _uhy_ ## 6 = (__m512)_mm512_mask_xor_epi32((__m512i)_uhy_ ## 6,0x0FF0,(__m512i)_uhy_ ## 6,(__m512i)neg);\
  _yy_ ## 1 = _mm512_add_ps(_yy_ ## 1,_uhy_ ## 1);\
  _yy_ ## 2 = _mm512_add_ps(_yy_ ## 2,_uhy_ ## 2);\
  _yy_ ## 3 = _mm512_add_ps(_yy_ ## 3,_uhy_ ## 3);\
  _yy_ ## 4 = _mm512_add_ps(_yy_ ## 4,_uhy_ ## 4);\
  _yy_ ## 5 = _mm512_add_ps(_yy_ ## 5,_uhy_ ## 5);\
  _yy_ ## 6 = _mm512_add_ps(_yy_ ## 6,_uhy_ ## 6);\
}

#define __mic_mult_proj_pre_back_z(_hy_,_yptr_) {\
  register __m512  neg = _mm512_set1_ps(-0.0f);\
  register __m512  _hy_ ## 4, _hy_ ## 5, _hy_ ## 6;\
  _hy_ ## 1 = _mm512_load_ps((char*)&((*_yptr_).y[0]));\
  _hy_ ## 2 = _mm512_load_ps((char*)&((*_yptr_).y[1]));\
  _hy_ ## 3 = _mm512_load_ps((char*)&((*_yptr_).y[2]));\
  _hy_ ## 4 = _mm512_load_ps((char*)&((*_yptr_).y[3]));\
  _hy_ ## 5 = _mm512_load_ps((char*)&((*_yptr_).y[4]));\
  _hy_ ## 6 = _mm512_load_ps((char*)&((*_yptr_).y[5]));\
  _hy_ ## 4 = (__m512)_mm512_permute4f128_epi32((__m512i)_hy_ ## 4,_MM_PERM_BADC);/* _hy_ ## 4 = (y14r, y13r, y14i, y13i) */\
  _hy_ ## 5 = (__m512)_mm512_permute4f128_epi32((__m512i)_hy_ ## 5,_MM_PERM_BADC);/* _hy_ ## 6 = (y24r, y23r, y24i, y23i) */\
  _hy_ ## 6 = (__m512)_mm512_permute4f128_epi32((__m512i)_hy_ ## 6,_MM_PERM_BADC);/* _hy_ ## 6 = (y34r, y33r, y34i, y33i) */\
  _hy_ ## 4 = (__m512)_mm512_mask_xor_epi32((__m512i)_hy_ ## 4,0x0FF0,(__m512i)_hy_ ## 4,(__m512i)neg);/* _hy_ ## 4 = ( y14r,-y13r,-y14i, y13i) */\
  _hy_ ## 5 = (__m512)_mm512_mask_xor_epi32((__m512i)_hy_ ## 5,0x0FF0,(__m512i)_hy_ ## 5,(__m512i)neg);/* _hy_ ## 5 = ( y24r,-y23r,-y24i, y23i) */\
  _hy_ ## 6 = (__m512)_mm512_mask_xor_epi32((__m512i)_hy_ ## 6,0x0FF0,(__m512i)_hy_ ## 6,(__m512i)neg);/* _hy_ ## 6 = ( y34r,-y33r,-y34i, y33i) */\
  _hy_ ## 1 = _mm512_add_ps(_hy_ ## 1,_hy_ ## 4);\
  _hy_ ## 2 = _mm512_add_ps(_hy_ ## 2,_hy_ ## 5);\
  _hy_ ## 3 = _mm512_add_ps(_hy_ ## 3,_hy_ ## 6);\
}

#define __mic_mult_proj_post_back_z(_yy_,_uhy_) {\
  register __m512  neg = _mm512_set1_ps(-0.0f);\
  register __m512  _uhy_ ## 4, _uhy_ ## 5, _uhy_ ## 6;\
  _uhy_ ## 4 = (__m512)_mm512_permute4f128_epi32((__m512i)_uhy_ ## 1,_MM_PERM_BADC);\
  _uhy_ ## 5 = (__m512)_mm512_permute4f128_epi32((__m512i)_uhy_ ## 2,_MM_PERM_BADC);\
  _uhy_ ## 6 = (__m512)_mm512_permute4f128_epi32((__m512i)_uhy_ ## 3,_MM_PERM_BADC);\
  _uhy_ ## 4 = (__m512)_mm512_mask_xor_epi32((__m512i)_uhy_ ## 4,0xF00F,(__m512i)_uhy_ ## 4,(__m512i)neg);\
  _uhy_ ## 5 = (__m512)_mm512_mask_xor_epi32((__m512i)_uhy_ ## 5,0xF00F,(__m512i)_uhy_ ## 5,(__m512i)neg);\
  _uhy_ ## 6 = (__m512)_mm512_mask_xor_epi32((__m512i)_uhy_ ## 6,0xF00F,(__m512i)_uhy_ ## 6,(__m512i)neg);\
  _yy_ ## 1 = _mm512_add_ps(_yy_ ## 1,_uhy_ ## 1);\
  _yy_ ## 2 = _mm512_add_ps(_yy_ ## 2,_uhy_ ## 2);\
  _yy_ ## 3 = _mm512_add_ps(_yy_ ## 3,_uhy_ ## 3);\
  _yy_ ## 4 = _mm512_add_ps(_yy_ ## 4,_uhy_ ## 4);\
  _yy_ ## 5 = _mm512_add_ps(_yy_ ## 5,_uhy_ ## 5);\
  _yy_ ## 6 = _mm512_add_ps(_yy_ ## 6,_uhy_ ## 6);\
}


/////////////////////
// Y-direction
/////////////////////
#define __mic_mult_proj_pre_forw_y(_hy_,_yptr_) {\
  register __m512  neg = _mm512_set1_ps(-0.0f);\
  register __m512  _hy_ ## 4, _hy_ ## 5, _hy_ ## 6;\
  _hy_ ## 1 = _mm512_load_ps((char*)&((*_yptr_).y[0]));\
  _hy_ ## 2 = _mm512_load_ps((char*)&((*_yptr_).y[1]));\
  _hy_ ## 3 = _mm512_load_ps((char*)&((*_yptr_).y[2]));\
  _hy_ ## 4 = _mm512_load_ps((char*)&((*_yptr_).y[3]));\
  _hy_ ## 5 = _mm512_load_ps((char*)&((*_yptr_).y[4]));\
  _hy_ ## 6 = _mm512_load_ps((char*)&((*_yptr_).y[5]));\
  _hy_ ## 4 = (__m512)_mm512_permute4f128_epi32((__m512i)_hy_ ## 4,_MM_PERM_CDAB);/* _hy_ ## 4 = ( y13i, y14i, y13r, y14r) */\
  _hy_ ## 5 = (__m512)_mm512_permute4f128_epi32((__m512i)_hy_ ## 5,_MM_PERM_CDAB);/* _hy_ ## 6 = ( y23i, y24i, y23r, y24r) */\
  _hy_ ## 6 = (__m512)_mm512_permute4f128_epi32((__m512i)_hy_ ## 6,_MM_PERM_CDAB);/* _hy_ ## 6 = ( y33i, y34i, y33r, y34r) */\
  _hy_ ## 4 = (__m512)_mm512_mask_xor_epi32((__m512i)_hy_ ## 4,0xF0F0,(__m512i)_hy_ ## 4,(__m512i)neg);/* _hy_ ## 4 = (-y13i, y14i,-y13r, y14r) */\
  _hy_ ## 5 = (__m512)_mm512_mask_xor_epi32((__m512i)_hy_ ## 5,0xF0F0,(__m512i)_hy_ ## 5,(__m512i)neg);/* _hy_ ## 5 = (-y23i, y24i,-y23r, y24r) */\
  _hy_ ## 6 = (__m512)_mm512_mask_xor_epi32((__m512i)_hy_ ## 6,0xF0F0,(__m512i)_hy_ ## 6,(__m512i)neg);/* _hy_ ## 6 = (-y33i, y34i,-y33r, y34r) */\
  _hy_ ## 1 = _mm512_add_ps(_hy_ ## 1,_hy_ ## 4);\
  _hy_ ## 2 = _mm512_add_ps(_hy_ ## 2,_hy_ ## 5);\
  _hy_ ## 3 = _mm512_add_ps(_hy_ ## 3,_hy_ ## 6);\
}

#define __mic_mult_proj_post_forw_y(_yy_,_uhy_) {\
  register __m512  neg = _mm512_set1_ps(-0.0f);\
  register __m512  _uhy_ ## 4, _uhy_ ## 5, _uhy_ ## 6;\
  _uhy_ ## 4 = (__m512)_mm512_permute4f128_epi32((__m512i)_uhy_ ## 1,_MM_PERM_CDAB);\
  _uhy_ ## 5 = (__m512)_mm512_permute4f128_epi32((__m512i)_uhy_ ## 2,_MM_PERM_CDAB);\
  _uhy_ ## 6 = (__m512)_mm512_permute4f128_epi32((__m512i)_uhy_ ## 3,_MM_PERM_CDAB);\
  _uhy_ ## 4 = (__m512)_mm512_mask_xor_epi32((__m512i)_uhy_ ## 4,0x0F0F,(__m512i)_uhy_ ## 4,(__m512i)neg);\
  _uhy_ ## 5 = (__m512)_mm512_mask_xor_epi32((__m512i)_uhy_ ## 5,0x0F0F,(__m512i)_uhy_ ## 5,(__m512i)neg);\
  _uhy_ ## 6 = (__m512)_mm512_mask_xor_epi32((__m512i)_uhy_ ## 6,0x0F0F,(__m512i)_uhy_ ## 6,(__m512i)neg);\
  _yy_ ## 1 = _mm512_add_ps(_yy_ ## 1,_uhy_ ## 1);\
  _yy_ ## 2 = _mm512_add_ps(_yy_ ## 2,_uhy_ ## 2);\
  _yy_ ## 3 = _mm512_add_ps(_yy_ ## 3,_uhy_ ## 3);\
  _yy_ ## 4 = _mm512_add_ps(_yy_ ## 4,_uhy_ ## 4);\
  _yy_ ## 5 = _mm512_add_ps(_yy_ ## 5,_uhy_ ## 5);\
  _yy_ ## 6 = _mm512_add_ps(_yy_ ## 6,_uhy_ ## 6);\
}


#define __mic_mult_proj_pre_back_y(_hy_,_yptr_) {\
  register __m512  neg = _mm512_set1_ps(-0.0f);\
  register __m512  _hy_ ## 4, _hy_ ## 5, _hy_ ## 6;\
  _hy_ ## 1 = _mm512_load_ps((char*)&((*_yptr_).y[0]));\
  _hy_ ## 2 = _mm512_load_ps((char*)&((*_yptr_).y[1]));\
  _hy_ ## 3 = _mm512_load_ps((char*)&((*_yptr_).y[2]));\
  _hy_ ## 4 = _mm512_load_ps((char*)&((*_yptr_).y[3]));\
  _hy_ ## 5 = _mm512_load_ps((char*)&((*_yptr_).y[4]));\
  _hy_ ## 6 = _mm512_load_ps((char*)&((*_yptr_).y[5]));\
  _hy_ ## 4 = (__m512)_mm512_permute4f128_epi32((__m512i)_hy_ ## 4,_MM_PERM_CDAB);/* _hy_ ## 4 = (y13i, y14i, y13r, y14r) */\
  _hy_ ## 5 = (__m512)_mm512_permute4f128_epi32((__m512i)_hy_ ## 5,_MM_PERM_CDAB);/* _hy_ ## 6 = (y23i, y24i, y23r, y24r) */\
  _hy_ ## 6 = (__m512)_mm512_permute4f128_epi32((__m512i)_hy_ ## 6,_MM_PERM_CDAB);/* _hy_ ## 6 = (y33i, y34i, y33r, y34r) */\
  _hy_ ## 4 = (__m512)_mm512_mask_xor_epi32((__m512i)_hy_ ## 4,0x0F0F,(__m512i)_hy_ ## 4,(__m512i)neg);/* _hy_ ## 4 = ( y13i,-y14i, y13r,-y14r) */\
  _hy_ ## 5 = (__m512)_mm512_mask_xor_epi32((__m512i)_hy_ ## 5,0x0F0F,(__m512i)_hy_ ## 5,(__m512i)neg);/* _hy_ ## 5 = ( y23i,-y24i, y23r,-y24r) */\
  _hy_ ## 6 = (__m512)_mm512_mask_xor_epi32((__m512i)_hy_ ## 6,0x0F0F,(__m512i)_hy_ ## 6,(__m512i)neg);/* _hy_ ## 6 = ( y33i,-y34i, y33r,-y34r) */\
  _hy_ ## 1 = _mm512_add_ps(_hy_ ## 1,_hy_ ## 4);\
  _hy_ ## 2 = _mm512_add_ps(_hy_ ## 2,_hy_ ## 5);\
  _hy_ ## 3 = _mm512_add_ps(_hy_ ## 3,_hy_ ## 6);\
}

#define __mic_mult_proj_post_back_y(_yy_,_uhy_) {\
  register __m512  neg = _mm512_set1_ps(-0.0f);\
  register __m512  _uhy_ ## 4, _uhy_ ## 5, _uhy_ ## 6;\
  _uhy_ ## 4 = (__m512)_mm512_permute4f128_epi32((__m512i)_uhy_ ## 1,_MM_PERM_CDAB);\
  _uhy_ ## 5 = (__m512)_mm512_permute4f128_epi32((__m512i)_uhy_ ## 2,_MM_PERM_CDAB);\
  _uhy_ ## 6 = (__m512)_mm512_permute4f128_epi32((__m512i)_uhy_ ## 3,_MM_PERM_CDAB);\
  _uhy_ ## 4 = (__m512)_mm512_mask_xor_epi32((__m512i)_uhy_ ## 4,0xF0F0,(__m512i)_uhy_ ## 4,(__m512i)neg);\
  _uhy_ ## 5 = (__m512)_mm512_mask_xor_epi32((__m512i)_uhy_ ## 5,0xF0F0,(__m512i)_uhy_ ## 5,(__m512i)neg);\
  _uhy_ ## 6 = (__m512)_mm512_mask_xor_epi32((__m512i)_uhy_ ## 6,0xF0F0,(__m512i)_uhy_ ## 6,(__m512i)neg);\
  _yy_ ## 1 = _mm512_add_ps(_yy_ ## 1,_uhy_ ## 1);\
  _yy_ ## 2 = _mm512_add_ps(_yy_ ## 2,_uhy_ ## 2);\
  _yy_ ## 3 = _mm512_add_ps(_yy_ ## 3,_uhy_ ## 3);\
  _yy_ ## 4 = _mm512_add_ps(_yy_ ## 4,_uhy_ ## 4);\
  _yy_ ## 5 = _mm512_add_ps(_yy_ ## 5,_uhy_ ## 5);\
  _yy_ ## 6 = _mm512_add_ps(_yy_ ## 6,_uhy_ ## 6);\
}

/////////////////////
// X-direction
/////////////////////
#define __mic_mult_proj_pre_forw_x(_hy_,_yptr_) {\
  register __m512  neg = _mm512_set1_ps(-0.0f);\
  register __m512  _hy_ ## 4, _hy_ ## 5, _hy_ ## 6;\
  _hy_ ## 1 = _mm512_load_ps((char*)&((*_yptr_).y[0]));\
  _hy_ ## 2 = _mm512_load_ps((char*)&((*_yptr_).y[1]));\
  _hy_ ## 3 = _mm512_load_ps((char*)&((*_yptr_).y[2]));\
  _hy_ ## 4 = _mm512_load_ps((char*)&((*_yptr_).y[3]));\
  _hy_ ## 5 = _mm512_load_ps((char*)&((*_yptr_).y[4]));\
  _hy_ ## 6 = _mm512_load_ps((char*)&((*_yptr_).y[5]));\
  _hy_ ## 4 = (__m512)_mm512_permute4f128_epi32((__m512i)_hy_ ## 4,_MM_PERM_ABCD);/* _hy_ ## 4 = (y13r, y14r, y13i, y14i) */\
  _hy_ ## 5 = (__m512)_mm512_permute4f128_epi32((__m512i)_hy_ ## 5,_MM_PERM_ABCD);/* _hy_ ## 6 = (y23r, y24r, y23i, y24i) */\
  _hy_ ## 6 = (__m512)_mm512_permute4f128_epi32((__m512i)_hy_ ## 6,_MM_PERM_ABCD);/* _hy_ ## 6 = (y33r, y34r, y33i, y34i) */\
  _hy_ ## 4 = (__m512)_mm512_mask_xor_epi32((__m512i)_hy_ ## 4,0x00FF,(__m512i)_hy_ ## 4,(__m512i)neg);/* _hy_ ## 4 = ( y13r, y14r,-y13i,-y14i) */\
  _hy_ ## 5 = (__m512)_mm512_mask_xor_epi32((__m512i)_hy_ ## 5,0x00FF,(__m512i)_hy_ ## 5,(__m512i)neg);/* _hy_ ## 5 = ( y23r, y24r,-y23i,-y24i) */\
  _hy_ ## 6 = (__m512)_mm512_mask_xor_epi32((__m512i)_hy_ ## 6,0x00FF,(__m512i)_hy_ ## 6,(__m512i)neg);/* _hy_ ## 6 = ( y33r, y34r,-y33i,-y34i) */\
  _hy_ ## 1 = _mm512_add_ps(_hy_ ## 1,_hy_ ## 4);\
  _hy_ ## 2 = _mm512_add_ps(_hy_ ## 2,_hy_ ## 5);\
  _hy_ ## 3 = _mm512_add_ps(_hy_ ## 3,_hy_ ## 6);\
}

#define __mic_mult_proj_post_forw_x(_yy_,_uhy_) {\
  register __m512  neg = _mm512_set1_ps(-0.0f);\
  register __m512  _uhy_ ## 4, _uhy_ ## 5, _uhy_ ## 6;\
  _uhy_ ## 4 = (__m512)_mm512_permute4f128_epi32((__m512i)_uhy_ ## 1,_MM_PERM_ABCD);\
  _uhy_ ## 5 = (__m512)_mm512_permute4f128_epi32((__m512i)_uhy_ ## 2,_MM_PERM_ABCD);\
  _uhy_ ## 6 = (__m512)_mm512_permute4f128_epi32((__m512i)_uhy_ ## 3,_MM_PERM_ABCD);\
  _uhy_ ## 4 = (__m512)_mm512_mask_xor_epi32((__m512i)_uhy_ ## 4,0xFF00,(__m512i)_uhy_ ## 4,(__m512i)neg);\
  _uhy_ ## 5 = (__m512)_mm512_mask_xor_epi32((__m512i)_uhy_ ## 5,0xFF00,(__m512i)_uhy_ ## 5,(__m512i)neg);\
  _uhy_ ## 6 = (__m512)_mm512_mask_xor_epi32((__m512i)_uhy_ ## 6,0xFF00,(__m512i)_uhy_ ## 6,(__m512i)neg);\
  _yy_ ## 1 = _mm512_add_ps(_yy_ ## 1,_uhy_ ## 1);\
  _yy_ ## 2 = _mm512_add_ps(_yy_ ## 2,_uhy_ ## 2);\
  _yy_ ## 3 = _mm512_add_ps(_yy_ ## 3,_uhy_ ## 3);\
  _yy_ ## 4 = _mm512_add_ps(_yy_ ## 4,_uhy_ ## 4);\
  _yy_ ## 5 = _mm512_add_ps(_yy_ ## 5,_uhy_ ## 5);\
  _yy_ ## 6 = _mm512_add_ps(_yy_ ## 6,_uhy_ ## 6);\
}

#define __mic_mult_proj_pre_back_x(_hy_,_yptr_) {\
  register __m512  neg = _mm512_set1_ps(-0.0f);\
  register __m512  _hy_ ## 4, _hy_ ## 5, _hy_ ## 6;\
  _hy_ ## 1 = _mm512_load_ps((char*)&((*_yptr_).y[0]));\
  _hy_ ## 2 = _mm512_load_ps((char*)&((*_yptr_).y[1]));\
  _hy_ ## 3 = _mm512_load_ps((char*)&((*_yptr_).y[2]));\
  _hy_ ## 4 = _mm512_load_ps((char*)&((*_yptr_).y[3]));\
  _hy_ ## 5 = _mm512_load_ps((char*)&((*_yptr_).y[4]));\
  _hy_ ## 6 = _mm512_load_ps((char*)&((*_yptr_).y[5]));\
  _hy_ ## 4 = (__m512)_mm512_permute4f128_epi32((__m512i)_hy_ ## 4,_MM_PERM_ABCD);/* _hy_ ## 4 = (y13r, y14r, y13i, y14i) */\
  _hy_ ## 5 = (__m512)_mm512_permute4f128_epi32((__m512i)_hy_ ## 5,_MM_PERM_ABCD);/* _hy_ ## 5 = (y23r, y24r, y23i, y24i) */\
  _hy_ ## 6 = (__m512)_mm512_permute4f128_epi32((__m512i)_hy_ ## 6,_MM_PERM_ABCD);/* _hy_ ## 6 = (y33r, y34r, y33i, y34i) */\
  _hy_ ## 4 = (__m512)_mm512_mask_xor_epi32((__m512i)_hy_ ## 4,0xFF00,(__m512i)_hy_ ## 4,(__m512i)neg);/* _hy_ ## 4 = (-y13r,-y14r, y13i, y14i) */\
  _hy_ ## 5 = (__m512)_mm512_mask_xor_epi32((__m512i)_hy_ ## 5,0xFF00,(__m512i)_hy_ ## 5,(__m512i)neg);/* _hy_ ## 5 = (-y23r,-y24r, y23i, y24i) */\
  _hy_ ## 6 = (__m512)_mm512_mask_xor_epi32((__m512i)_hy_ ## 6,0xFF00,(__m512i)_hy_ ## 6,(__m512i)neg);/* _hy_ ## 6 = (-y33r,-y34r, y33i, y34i) */\
  _hy_ ## 1 = _mm512_add_ps(_hy_ ## 1,_hy_ ## 4);\
  _hy_ ## 2 = _mm512_add_ps(_hy_ ## 2,_hy_ ## 5);\
  _hy_ ## 3 = _mm512_add_ps(_hy_ ## 3,_hy_ ## 6);\
}

#define __mic_mult_proj_post_back_x(_yy_,_uhy_) {\
  register __m512  neg = _mm512_set1_ps(-0.0f);\
  register __m512  _uhy_ ## 4, _uhy_ ## 5, _uhy_ ## 6;\
  _uhy_ ## 4 = (__m512)_mm512_permute4f128_epi32((__m512i)_uhy_ ## 1,_MM_PERM_ABCD);\
  _uhy_ ## 5 = (__m512)_mm512_permute4f128_epi32((__m512i)_uhy_ ## 2,_MM_PERM_ABCD);\
  _uhy_ ## 6 = (__m512)_mm512_permute4f128_epi32((__m512i)_uhy_ ## 3,_MM_PERM_ABCD);\
  _uhy_ ## 4 = (__m512)_mm512_mask_xor_epi32((__m512i)_uhy_ ## 4,0x00FF,(__m512i)_uhy_ ## 4,(__m512i)neg);\
  _uhy_ ## 5 = (__m512)_mm512_mask_xor_epi32((__m512i)_uhy_ ## 5,0x00FF,(__m512i)_uhy_ ## 5,(__m512i)neg);\
  _uhy_ ## 6 = (__m512)_mm512_mask_xor_epi32((__m512i)_uhy_ ## 6,0x00FF,(__m512i)_uhy_ ## 6,(__m512i)neg);\
  _yy_ ## 1 = _mm512_add_ps(_yy_ ## 1,_uhy_ ## 1);\
  _yy_ ## 2 = _mm512_add_ps(_yy_ ## 2,_uhy_ ## 2);\
  _yy_ ## 3 = _mm512_add_ps(_yy_ ## 3,_uhy_ ## 3);\
  _yy_ ## 4 = _mm512_add_ps(_yy_ ## 4,_uhy_ ## 4);\
  _yy_ ## 5 = _mm512_add_ps(_yy_ ## 5,_uhy_ ## 5);\
  _yy_ ## 6 = _mm512_add_ps(_yy_ ## 6,_uhy_ ## 6);\
}


//////////////////
// Clover term
//////////////////
#define __mic_mult_clvoer_term(_yy_,_fptr_) {\
  register __m512 a1,a2,a3;\
  register __m512 b1,b2,b3;\
  {\
    {\
      register __m512 m1,m2,m3;\
      /*******************************/\
      /* m(1:2) = yy(1:2) - yy(3:4)  */\
      /*******************************/\
      m1 = _mm512_sub_ps(_yy_ ## 1,_yy_ ## 4);\
      m2 = _mm512_sub_ps(_yy_ ## 2,_yy_ ## 5);\
      m3 = _mm512_sub_ps(_yy_ ## 3,_yy_ ## 6);\
\
      /****************/\
      /*  b = f * m   */\
      /****************/\
      __mic_mult_clover_m6x6(b,((*_fptr_).c[0].f),m);\
    }\
    {\
      register __m512 p1,p2,p3;\
      /*******************************/\
      /* p(1:2) = yy(1:2) + yy(3:4)  */\
      /*******************************/\
      p1 = _mm512_add_ps(yy1,yy4);\
      p2 = _mm512_add_ps(yy2,yy5);\
      p3 = _mm512_add_ps(yy3,yy6);\
\
      /****************/\
      /* a = f * p    */\
      /****************/\
      __mic_mult_clover_m6x6(a,((*_fptr_).c[1].f),p);\
    }\
  }\
\
  _yy_ ## 1 = _mm512_add_ps(a1,b1);\
  _yy_ ## 2 = _mm512_add_ps(a2,b2);\
  _yy_ ## 3 = _mm512_add_ps(a3,b3);\
  _yy_ ## 4 = _mm512_sub_ps(a1,b1);\
  _yy_ ## 5 = _mm512_sub_ps(a2,b2);\
  _yy_ ## 6 = _mm512_sub_ps(a3,b3);\
}

///////////////////////////////////////////////////////////////////////////////
// y := u*y
#define __mic_su3_gmult_vec(_u_, _y_) {\
  register __m512 uu1,uu2,uu3,u3r,u3i;\
  register __m512 tu1,tu2,tu3;\
  register __m512 tt1,tt2,tt3;\
  register __m512 ss1,ss2,ss3;\
  register __m512 neg;\
\
  neg  = _mm512_set1_ps(-0.0f);\
\
  uu1 = _u_ ## 1;/* uu1 = (u12i, u11i, u12r, u11r) */\
  uu2 = _u_ ## 2;/* uu2 = (u22i, u21i, u22r, u21r) */\
  uu3 = _u_ ## 3;/* uu3 = (u32i, u31i, u32r, u31r) */\
\
  /**************************************\
  *  reconstruct the 3rd component of u *\
  **************************************/\
  /******************************\
  *  real part of (u31,u32,u33) *\
  ******************************/\
  tu1 = (__m512)_mm512_permute4f128_epi32((__m512i)uu1,_MM_PERM_CDAB);\
  tu2 = (__m512)_mm512_permute4f128_epi32((__m512i)uu2,_MM_PERM_CDAB);\
\
  tt1 = _mm512_mul_ps(tu2,uu3);\
  tt2 = _mm512_mul_ps(tu1,uu3);\
  tt3 = _mm512_mul_ps(tu2,uu1);\
\
  tt1 = (__m512)_mm512_mask_xor_epi32((__m512i)tt1,0xF00F,(__m512i)tt1,(__m512i)neg);\
  tt2 = (__m512)_mm512_mask_xor_epi32((__m512i)tt2,0x0FF0,(__m512i)tt2,(__m512i)neg);\
  tt3 = (__m512)_mm512_mask_xor_epi32((__m512i)tt3,0x0FF0,(__m512i)tt3,(__m512i)neg);\
\
  tt2 = (__m512)_mm512_permute4f128_epi32((__m512i)tt2,_MM_PERM_CBAD);\
  tt3 = (__m512)_mm512_permute4f128_epi32((__m512i)tt3,_MM_PERM_BADC);\
\
  ss1 = _mm512_mask_blend_ps(0xF0F0,tt1,tt2);\
  tt1 = _mm512_mask_blend_ps(0x0F0F,tt1,tt2);\
\
  tt2 = _mm512_mask_blend_ps(0xFF00,ss1,tt3);\
  ss1 = _mm512_mask_blend_ps(0x00FF,ss1,tt3);\
  ss3 = _mm512_mask_blend_ps(0xF00F,tt1,tt3);\
  tt1 = _mm512_mask_blend_ps(0x0FF0,tt1,tt3);\
\
  ss1 = (__m512)_mm512_permute4f128_epi32((__m512i)ss1,_MM_PERM_BADC);\
  ss3 = (__m512)_mm512_permute4f128_epi32((__m512i)ss3,_MM_PERM_ADCB);\
  tt1 = (__m512)_mm512_permute4f128_epi32((__m512i)tt1,_MM_PERM_CBAD);\
\
  tt2 = _mm512_add_ps(tt2,ss1);\
  tt1 = _mm512_add_ps(tt1,ss3);\
  u3r = _mm512_add_ps(tt1,tt2);\
\
  /******************************\
  *  imag part of (u31,u32,u33) *\
  ******************************/\
\
  tu1 = (__m512)_mm512_permute4f128_epi32((__m512i)uu1,_MM_PERM_ABCD);\
  tu2 = (__m512)_mm512_permute4f128_epi32((__m512i)uu2,_MM_PERM_ABCD);\
\
  tt1 = _mm512_mul_ps(tu2,uu3);\
  tt2 = _mm512_mul_ps(tu1,uu3);\
  tt3 = _mm512_mul_ps(tu2,uu1);\
\
  tt1 = (__m512)_mm512_mask_xor_epi32((__m512i)tt1,0xF0F0,(__m512i)tt1,(__m512i)neg);\
  tt2 = (__m512)_mm512_mask_xor_epi32((__m512i)tt2,0x0F0F,(__m512i)tt2,(__m512i)neg);\
  tt3 = (__m512)_mm512_mask_xor_epi32((__m512i)tt3,0x0F0F,(__m512i)tt3,(__m512i)neg);\
\
  tt2 = (__m512)_mm512_permute4f128_epi32((__m512i)tt2,_MM_PERM_CBAD);\
  tt3 = (__m512)_mm512_permute4f128_epi32((__m512i)tt3,_MM_PERM_BADC);\
\
  ss1 = _mm512_mask_blend_ps(0xF0F0,tt1,tt2);\
  tt1 = _mm512_mask_blend_ps(0x0F0F,tt1,tt2);\
\
  tt2 = _mm512_mask_blend_ps(0xFF00,ss1,tt3);\
  ss1 = _mm512_mask_blend_ps(0x00FF,ss1,tt3);\
  ss3 = _mm512_mask_blend_ps(0xF00F,tt1,tt3);\
  tt1 = _mm512_mask_blend_ps(0x0FF0,tt1,tt3);\
\
  ss1 = (__m512)_mm512_permute4f128_epi32((__m512i)ss1,_MM_PERM_BADC);\
  ss3 = (__m512)_mm512_permute4f128_epi32((__m512i)ss3,_MM_PERM_ADCB);\
  tt1 = (__m512)_mm512_permute4f128_epi32((__m512i)tt1,_MM_PERM_CBAD);\
\
  tt2 = _mm512_add_ps(tt2,ss1);\
  tt1 = _mm512_add_ps(tt1,ss3);\
  u3i = _mm512_add_ps(tt1,tt2);\
\
  /************************\
  * w = u * y  (2-spinor) *\
  ************************/\
  tt1 = _y_ ## 1; /* tt1 = (y12i,y11i,y12r,y11r) */\
  tt2 = _y_ ## 2; /* tt2 = (y22i,y21i,y22r,y21r) */\
  tt3 = _y_ ## 3; /* tt3 = (y32i,y31i,y32r,y31r) */\
\
  /* color = 1\
  *  tu1 = (u11r*y12i,u11r*y11i,u11r*y12r,u11r*y11r)    \
  *  ss3 = (u11i*y12i,u11i*y11i,u11i*y12r,u11i*y11r)    \
  */\
\
  ss1 = (__m512)_mm512_permute4f128_epi32((__m512i)uu1,_MM_PERM_AAAA); /* ss1 = (u11r,u11r,u11r,u11r) */\
  ss2 = (__m512)_mm512_permute4f128_epi32((__m512i)uu1,_MM_PERM_CCCC); /* ss2 = (u11i,u11i,u11i,u11i) */\
  tu1 = _mm512_mul_ps(ss1,tt1);\
  ss3 = _mm512_mul_ps(ss2,tt1);\
\
  /*\
  *  tu1 = (u12r*y22i, u12r*y21i, u12r*y22r, u12r*y21r) + tu1\
  *  ss3 = (u12i*y22i, u12i*y21i, u12i*y22r, u12i*y21r) + ss3\
  */\
  ss1 = (__m512)_mm512_permute4f128_epi32((__m512i)uu1,_MM_PERM_BBBB); /* ss1 = (u12r,u12r,u12r,u12r) */\
  ss2 = (__m512)_mm512_permute4f128_epi32((__m512i)uu1,_MM_PERM_DDDD); /* ss2 = (u12i,u12i,u12i,u12i) */\
  tu1 = _mm512_fmadd_ps(ss1,tt2,tu1);\
  ss3 = _mm512_fmadd_ps(ss2,tt2,ss3);\
\
  /*\
  *  tu1 = (u13r*y32i, u13r*y31i, u13r*y32r u13r*y31r) + tu1\
  *  ss3 = (u13i*y32i, u13i*y31i, u13i*y32r u13i*y31r) + ss3\
  */\
  ss1 = (__m512)_mm512_permute4f128_epi32((__m512i)u3r,_MM_PERM_AAAA); /* ss1 = (u13r,u13r,u13r,u13r) */\
  ss2 = (__m512)_mm512_permute4f128_epi32((__m512i)u3i,_MM_PERM_AAAA); /* ss2 = (u13i,u13i,u13i,u13i) */\
  tu1 = _mm512_fmadd_ps(ss1,tt3,tu1);\
  ss3 = _mm512_fmadd_ps(ss2,tt3,ss3);\
\
  ss3 = (__m512)_mm512_permute4f128_epi32((__m512i)ss3,_MM_PERM_BADC);\
  ss3 = (__m512)_mm512_mask_xor_epi32((__m512i)ss3,0x00FF,(__m512i)ss3,(__m512i)neg);\
  _y_ ## 1 = _mm512_add_ps(tu1,ss3);\
\
  /* color = 2\
  *\
  *  tu2 = (u21r*y12i, u21r*y11i, u21r*y12r, u21r*y11r)\
  *  ss3 = (u21i*y12i, u21i*y11i, u21i*y12r, u21i*y11r)\
  */\
  ss1 = (__m512)_mm512_permute4f128_epi32((__m512i)uu2,_MM_PERM_AAAA); /* ss1 = (u21r,u21r,u21r,u21r) */\
  ss2 = (__m512)_mm512_permute4f128_epi32((__m512i)uu2,_MM_PERM_CCCC); /* ss2 = (u21i,u21i,u21i,u21i) */\
  tu2 = _mm512_mul_ps(ss1,tt1);\
  ss3 = _mm512_mul_ps(ss2,tt1);\
\
  /*\
  *  tu2 = (u22r*y22i, u22r*y21i, u22r*y22r, u22r*y21r) + tu2\
  *  ss3 = (u22i*y22i, u22i*y21i, u22i*y22r, u22i*y21r) + ss3\
  */\
  ss1 = (__m512)_mm512_permute4f128_epi32((__m512i)uu2,_MM_PERM_BBBB); /* ss1 = (u22r,u22r,u22r,u22r) */\
  ss2 = (__m512)_mm512_permute4f128_epi32((__m512i)uu2,_MM_PERM_DDDD); /* ss2 = (u22i,u22i,u22i,u22i) */\
  tu2 = _mm512_fmadd_ps(ss1,tt2,tu2);\
  ss3 = _mm512_fmadd_ps(ss2,tt2,ss3);\
\
  /*\
  *  tu2 = (u23r*y32i, u23r*y31i, u23r*y32r, u23r*y31r) + tu3\
  *  ss3 = (u23i*y32i, u23i*y31i, u23i*y32r, u23i*y31r) + ss3\
  */\
  ss1 = (__m512)_mm512_permute4f128_epi32((__m512i)u3r,_MM_PERM_BBBB); /* ss1 = (u23r,u23r,u23r,u23r) */\
  ss2 = (__m512)_mm512_permute4f128_epi32((__m512i)u3i,_MM_PERM_BBBB); /* ss2 = (u23i,u23i,u23i,u23i) */\
  tu2 = _mm512_fmadd_ps(ss1,tt3,tu2);\
  ss3 = _mm512_fmadd_ps(ss2,tt3,ss3);\
\
  ss3 = (__m512)_mm512_permute4f128_epi32((__m512i)ss3,_MM_PERM_BADC);\
  ss3 = (__m512)_mm512_mask_xor_epi32((__m512i)ss3,0x00FF,(__m512i)ss3,(__m512i)neg);\
  _y_ ## 2 = _mm512_add_ps(tu2,ss3);\
\
  /* color = 3\
  *\
  *  tu3 = (u31r*y12i, u31r*y11i, u31r*y12r, u31r*y11r)\
  *  ss3 = (u31i*y12i, u31i*y11i, u31i*y12r, u31i*y11r)\
  */\
  ss1 = (__m512)_mm512_permute4f128_epi32((__m512i)uu3,_MM_PERM_AAAA); /* ss1 = (u31r,u31r,u31r,u31r) */\
  ss2 = (__m512)_mm512_permute4f128_epi32((__m512i)uu3,_MM_PERM_CCCC); /* ss2 = (u31i,u31i,u31i,u31i) */\
  tu3 = _mm512_mul_ps(ss1,tt1);\
  ss3 = _mm512_mul_ps(ss2,tt1);\
\
  /*\
  *  tu3 = (u32r*y22i, u32r*y21i, u32r*y22r, u32r*y21r) + tu3\
  *  ss3 = (u32i*y22i, u32i*y21i, u32i*y22r, u32i*y21r) + ss3\
  */\
  ss1 = (__m512)_mm512_permute4f128_epi32((__m512i)uu3,_MM_PERM_BBBB); /* ss1 = (u32r,u32r,u32r,u32r) */\
  ss2 = (__m512)_mm512_permute4f128_epi32((__m512i)uu3,_MM_PERM_DDDD); /* ss2 = (u32i,u32i,u32i,u32i) */\
  tu3 = _mm512_fmadd_ps(ss1,tt2,tu3);\
  ss3 = _mm512_fmadd_ps(ss2,tt2,ss3);\
\
  /*\
  *  tu3 = (u33r*y32i, u33r*y31i, u33r*y32r, u33r*y31r) + tu3\
  *  ss3 = (u33i*y32i, u33i*y31i, u33i*y32r, u33i*y31r) + ss3\
  */\
  ss1 = (__m512)_mm512_permute4f128_epi32((__m512i)u3r,_MM_PERM_CCCC); /* ss1 = (u33r,u33r,u33r,u33r) */\
  ss2 = (__m512)_mm512_permute4f128_epi32((__m512i)u3i,_MM_PERM_CCCC); /* ss2 = (u33i,u33i,u33i,u33i) */\
  tu3 = _mm512_fmadd_ps(ss1,tt3,tu3);\
  ss3 = _mm512_fmadd_ps(ss2,tt3,ss3);\
\
  ss3 = (__m512)_mm512_permute4f128_epi32((__m512i)ss3,_MM_PERM_BADC);\
  ss3 = (__m512)_mm512_mask_xor_epi32((__m512i)ss3,0x00FF,(__m512i)ss3,(__m512i)neg);\
  _y_ ## 3 = _mm512_add_ps(tu3,ss3);\
}

//
// y := u^dag y
//
#define __mic_su3_gmultdag_vec(_u_, _y_) {\
  register __m512 uu1,uu2,uu3,u3r,u3i;\
  register __m512 tu1,tu2,tu3;\
  register __m512 tt1,tt2,tt3;\
  register __m512 ss1,ss2,ss3;\
  register __m512 neg;\
\
  neg  = _mm512_set1_ps(-0.0f);\
\
  uu1 = _u_ ## 1;/* uu1 = (u12i, u11i, u12r, u11r) */\
  uu2 = _u_ ## 2;/* uu2 = (u22i, u21i, u22r, u21r) */\
  uu3 = _u_ ## 3;/* uu3 = (u32i, u31i, u32r, u31r) */\
\
  /**************************************\
  *  reconstruct the 3rd component of u *\
  **************************************/\
  /******************************\
  *  real part of (u31,u32,u33) *\
  ******************************/\
  tu1 = (__m512)_mm512_permute4f128_epi32((__m512i)uu1,_MM_PERM_CDAB);\
  tu2 = (__m512)_mm512_permute4f128_epi32((__m512i)uu2,_MM_PERM_CDAB);\
\
  tt1 = _mm512_mul_ps(tu2,uu3);\
  tt2 = _mm512_mul_ps(tu1,uu3);\
  tt3 = _mm512_mul_ps(tu2,uu1);\
\
  tt1 = (__m512)_mm512_mask_xor_epi32((__m512i)tt1,0xF00F,(__m512i)tt1,(__m512i)neg);\
  tt2 = (__m512)_mm512_mask_xor_epi32((__m512i)tt2,0x0FF0,(__m512i)tt2,(__m512i)neg);\
  tt3 = (__m512)_mm512_mask_xor_epi32((__m512i)tt3,0x0FF0,(__m512i)tt3,(__m512i)neg);\
\
  tt2 = (__m512)_mm512_permute4f128_epi32((__m512i)tt2,_MM_PERM_CBAD);\
  tt3 = (__m512)_mm512_permute4f128_epi32((__m512i)tt3,_MM_PERM_BADC);\
\
  ss1 = _mm512_mask_blend_ps(0xF0F0,tt1,tt2);\
  tt1 = _mm512_mask_blend_ps(0x0F0F,tt1,tt2);\
\
  tt2 = _mm512_mask_blend_ps(0xFF00,ss1,tt3);\
  ss1 = _mm512_mask_blend_ps(0x00FF,ss1,tt3);\
  ss3 = _mm512_mask_blend_ps(0xF00F,tt1,tt3);\
  tt1 = _mm512_mask_blend_ps(0x0FF0,tt1,tt3);\
\
  ss1 = (__m512)_mm512_permute4f128_epi32((__m512i)ss1,_MM_PERM_BADC);\
  ss3 = (__m512)_mm512_permute4f128_epi32((__m512i)ss3,_MM_PERM_ADCB);\
  tt1 = (__m512)_mm512_permute4f128_epi32((__m512i)tt1,_MM_PERM_CBAD);\
\
  tt2 = _mm512_add_ps(tt2,ss1);\
  tt1 = _mm512_add_ps(tt1,ss3);\
  u3r = _mm512_add_ps(tt1,tt2);\
\
  /******************************\
  *  imag part of (u31,u32,u33) *\
  ******************************/\
\
  tu1 = (__m512)_mm512_permute4f128_epi32((__m512i)uu1,_MM_PERM_ABCD);\
  tu2 = (__m512)_mm512_permute4f128_epi32((__m512i)uu2,_MM_PERM_ABCD);\
\
  tt1 = _mm512_mul_ps(tu2,uu3);\
  tt2 = _mm512_mul_ps(tu1,uu3);\
  tt3 = _mm512_mul_ps(tu2,uu1);\
\
  tt1 = (__m512)_mm512_mask_xor_epi32((__m512i)tt1,0xF0F0,(__m512i)tt1,(__m512i)neg);\
  tt2 = (__m512)_mm512_mask_xor_epi32((__m512i)tt2,0x0F0F,(__m512i)tt2,(__m512i)neg);\
  tt3 = (__m512)_mm512_mask_xor_epi32((__m512i)tt3,0x0F0F,(__m512i)tt3,(__m512i)neg);\
\
  tt2 = (__m512)_mm512_permute4f128_epi32((__m512i)tt2,_MM_PERM_CBAD);\
  tt3 = (__m512)_mm512_permute4f128_epi32((__m512i)tt3,_MM_PERM_BADC);\
\
  ss1 = _mm512_mask_blend_ps(0xF0F0,tt1,tt2);\
  tt1 = _mm512_mask_blend_ps(0x0F0F,tt1,tt2);\
\
  tt2 = _mm512_mask_blend_ps(0xFF00,ss1,tt3);\
  ss1 = _mm512_mask_blend_ps(0x00FF,ss1,tt3);\
  ss3 = _mm512_mask_blend_ps(0xF00F,tt1,tt3);\
  tt1 = _mm512_mask_blend_ps(0x0FF0,tt1,tt3);\
\
  ss1 = (__m512)_mm512_permute4f128_epi32((__m512i)ss1,_MM_PERM_BADC);\
  ss3 = (__m512)_mm512_permute4f128_epi32((__m512i)ss3,_MM_PERM_ADCB);\
  tt1 = (__m512)_mm512_permute4f128_epi32((__m512i)tt1,_MM_PERM_CBAD);\
\
  tt2 = _mm512_add_ps(tt2,ss1);\
  tt1 = _mm512_add_ps(tt1,ss3);\
  u3i = _mm512_add_ps(tt1,tt2);\
\
  /*\
  *  w = u^dag * y  (2-spinor)\
  */\
  tt1 = _y_ ## 1;/* tt1 = (y12i,y11i,y12r,y11r) */\
  tt2 = _y_ ## 2;/* tt2 = (y22i,y21i,y22r,y21r) */\
  tt3 = _y_ ## 3;/* tt3 = (y32i,y31i,y32r,y31r) */\
\
  /* color = 1\
  *\
  *  tu1 = (u11r*y12i, u11r*y11i, u11r*y12r, u11r*y11r)\
  *  ss3 = (u11i*y12i, u11i*y11i, u11i*y12r, u11i*y11r)\
  */\
  ss1 = (__m512)_mm512_permute4f128_epi32((__m512i)uu1,_MM_PERM_AAAA); /* ss1 = (u11r,u11r,u11r,u11r) */\
  ss2 = (__m512)_mm512_permute4f128_epi32((__m512i)uu1,_MM_PERM_CCCC); /* ss2 = (u11i,u11i,u11i,u11i) */\
  tu1 = _mm512_mul_ps(ss1,tt1);\
  ss3 = _mm512_mul_ps(ss2,tt1);\
\
  /*\
  *  tu1 = (u21r*y22i, u21r*y21i, u21r*y22r, u21r*y21r) + tu1\
  *  ss3 = (u21i*y22i, u21i*y21i, u21i*y22r, u21i*y21r) + ss3\
  */\
  ss1 = (__m512)_mm512_permute4f128_epi32((__m512i)uu2,_MM_PERM_AAAA); /* ss1 = (u21r,u21r,u21r,u21r) */\
  ss2 = (__m512)_mm512_permute4f128_epi32((__m512i)uu2,_MM_PERM_CCCC); /* ss2 = (u21i,u21i,u21i,u21i) */\
  tu1 = _mm512_fmadd_ps(ss1,tt2,tu1);\
  ss3 = _mm512_fmadd_ps(ss2,tt2,ss3);\
\
  /*\
  *  tu1 = (u31r*y32i,u31r*y31i,u31r*y32r,u31r*y31r) + tu1\
  *  ss3 = (u31i*y32i,u31i*y31i,u31i*y32r,u31i*y31r) + ss3\
  */\
  ss1 = (__m512)_mm512_permute4f128_epi32((__m512i)uu3,_MM_PERM_AAAA); /* ss1 = (u31r,u31r,u31r,u31r) */\
  ss2 = (__m512)_mm512_permute4f128_epi32((__m512i)uu3,_MM_PERM_CCCC); /* ss2 = (u31i,u31i,u31i,u31i) */\
  tu1 = _mm512_fmadd_ps(ss1,tt3,tu1);\
  ss3 = _mm512_fmadd_ps(ss2,tt3,ss3);\
\
  ss3 = (__m512)_mm512_permute4f128_epi32((__m512i)ss3,_MM_PERM_BADC);\
  ss3 = (__m512)_mm512_mask_xor_epi32((__m512i)ss3,0xFF00,(__m512i)ss3,(__m512i)neg);\
  _y_ ## 1 = _mm512_add_ps(tu1,ss3);\
\
  /* color = 2\
  *\
  *  tu2 = (u12r*y12i,u12r*y11i,u12r*y12r,u12r*y11r)\
  *  ss3 = (u12i*y12i,u12i*y11i,u12i*y12r,u12i*y11r)\
  */\
  ss1 = (__m512)_mm512_permute4f128_epi32((__m512i)uu1,_MM_PERM_BBBB); /* ss1 = (u12r,u12r,u12r,u12r) */\
  ss2 = (__m512)_mm512_permute4f128_epi32((__m512i)uu1,_MM_PERM_DDDD); /* ss2 = (u12i,u12i,u12i,u12i) */\
  tu2 = _mm512_mul_ps(ss1,tt1);\
  ss3 = _mm512_mul_ps(ss2,tt1);\
\
  /*\
  *  tu2 = (u22r*y22i,u22r*y21i,u22r*y22r,u22r*y21r) + tu2\
  *  ss3 = (u22i*y22i,u22i*y21i,u22i*y22r,u22i*y21r) + ss3\
  */\
  ss1 = (__m512)_mm512_permute4f128_epi32((__m512i)uu2,_MM_PERM_BBBB); /* ss1 = (u22r,u22r,u22r,u22r) */\
  ss2 = (__m512)_mm512_permute4f128_epi32((__m512i)uu2,_MM_PERM_DDDD); /* ss2 = (u22i,u22i,u22i,u22i) */\
  tu2 = _mm512_fmadd_ps(ss1,tt2,tu2);\
  ss3 = _mm512_fmadd_ps(ss2,tt2,ss3);\
\
  /*\
  *  tu2 = (u32r*y32i,u32r*y31i,u32r*y32r,u32r*y31r) + tu2\
  *  ss3 = (u32i*y32i,u32i*y31i,u32i*y32r,u32i*y31r) + ss3\
  */\
  ss1 = (__m512)_mm512_permute4f128_epi32((__m512i)uu3,_MM_PERM_BBBB); /* ss1 = (u32r,u32r,u32r,u32r) */\
  ss2 = (__m512)_mm512_permute4f128_epi32((__m512i)uu3,_MM_PERM_DDDD); /* ss2 = (u32i,u32i,u32i,u32i) */\
  tu2 = _mm512_fmadd_ps(ss1,tt3,tu2);\
  ss3 = _mm512_fmadd_ps(ss2,tt3,ss3);\
\
  ss3 = (__m512)_mm512_permute4f128_epi32((__m512i)ss3,_MM_PERM_BADC);\
  ss3 = (__m512)_mm512_mask_xor_epi32((__m512i)ss3,0xFF00,(__m512i)ss3,(__m512i)neg);\
  _y_ ## 2 = _mm512_add_ps(tu2,ss3);\
\
  /* color = 3\
  *\
  *  tu3 = (u13r*y12i,u13r*y11i,u13r*y12r,u13r*y11r)\
  *  ss3 = (u13i*y12i,u13i*y11i,u13i*y12r,u13i*y11r)\
  */\
  ss1 = (__m512)_mm512_permute4f128_epi32((__m512i)u3r,_MM_PERM_AAAA); /* ss1 = (u13r,u13r,u13r,u13r) */\
  ss2 = (__m512)_mm512_permute4f128_epi32((__m512i)u3i,_MM_PERM_AAAA); /* ss2 = (u13i,u13i,u13i,u13i) */\
  tu3 = _mm512_mul_ps(ss1,tt1);\
  ss3 = _mm512_mul_ps(ss2,tt1);\
\
  /*\
  *  tu3 = (u23r*y22i,u23r*y21i,u23r*y22r,u23r*y21r) + tu3\
  *  ss3 = (u23i*y22i,u23i*y21i,u23i*y22r,u23i*y21r) + ss3\
  */\
  ss1 = (__m512)_mm512_permute4f128_epi32((__m512i)u3r,_MM_PERM_BBBB); /* ss1 = (u23r,u23r,u23r,u23r) */\
  ss2 = (__m512)_mm512_permute4f128_epi32((__m512i)u3i,_MM_PERM_BBBB); /* ss2 = (u23i,u23i,u23i,u23i) */\
  tu3 = _mm512_fmadd_ps(ss1,tt2,tu3);\
  ss3 = _mm512_fmadd_ps(ss2,tt2,ss3);\
\
  /*\
  *  tu3 = (u33r*y32i,u33r*y31i,u33r*y32r,u33r*y21r) + tu3\
  *  ss3 = (u33i*y32i,u33i*y31i,u33i*y32r,u33i*y21r) + ss3\
  */\
  ss1 = (__m512)_mm512_permute4f128_epi32((__m512i)u3r,_MM_PERM_CCCC); /* ss1 = (u33r,u33r,u33r,u33r) */\
  ss2 = (__m512)_mm512_permute4f128_epi32((__m512i)u3i,_MM_PERM_CCCC); /* ss2 = (u33i,u33i,u33i,u33i) */\
  tu3 = _mm512_fmadd_ps(ss1,tt3,tu3);\
  ss3 = _mm512_fmadd_ps(ss2,tt3,ss3);\
\
  ss3 = (__m512)_mm512_permute4f128_epi32((__m512i)ss3,_MM_PERM_BADC);\
  ss3 = (__m512)_mm512_mask_xor_epi32((__m512i)ss3,0xFF00,(__m512i)ss3,(__m512i)neg);\
  _y_ ## 3 = _mm512_add_ps(tu3,ss3);\
}

//
// w = f * y
//
#define __mic_mult_clover_m6x6(_w_, _fp_, _y_) {\
  register __m512 yy1,yy2,yy3;\
  register __m512 ff1,ff2;\
  register __m512 w1a,w2a,w3a;\
  register __m512 w1b,w2b,w3b;\
  register __m512 w1c,w2c,w3c;\
  register __m512 w1d,w2d,w3d;\
  register __m512 tt1,tt2,tt3;\
  register __m512 neg;\
\
  neg  = _mm512_set1_ps(-0.0f);\
\
  /*\
  * load half spinor\
  */\
  yy1 = _y_ ## 1;\
  yy2 = _y_ ## 2;\
  yy3 = _y_ ## 3;\
\
  ff1 = _mm512_load_ps((char *)&(_fp_[0]));                            /* ff1 = ( f4i, f4r,f16r, f1r) : diagonal block */\
  ff2 = _mm512_load_ps((char *)&(_fp_[1]));                            /* ff2 = (f17i, f2i,f17r, f2r) */\
\
  tt1 = (__m512)_mm512_permute4f128_epi32((__m512i)ff1,_MM_PERM_BABA); /* tt1 = (f16r, f1r,f16r, f1r) */\
  tt2 = (__m512)_mm512_permute4f128_epi32((__m512i)ff1,_MM_PERM_CCCC); /* tt2 = ( f4r, f4r, f4r, f4r) */\
  tt3 = (__m512)_mm512_permute4f128_epi32((__m512i)ff1,_MM_PERM_DDDD); /* tt3 = ( f4i, f4i, f4i, f4i) */\
  w1a = _mm512_mul_ps(tt1,yy1);\
  w1c = _mm512_mul_ps(tt2,yy1);\
  w1d = _mm512_mul_ps(tt3,yy1);\
\
  ff1 = _mm512_load_ps((char *)&(_fp_[2]));                            /* ff1 = ( f9i, f5i, f9r, f5r) */\
\
  tt1 = (__m512)_mm512_permute4f128_epi32((__m512i)ff2,_MM_PERM_BABA); /* tt1 = (f17r, f2r,f17r, f2r) */\
  tt2 = (__m512)_mm512_permute4f128_epi32((__m512i)ff2,_MM_PERM_DCDC); /* tt2 = (f17i, f2i,f17i, f2i) */\
  w1a = _mm512_fmadd_ps(tt1,yy2,w1a);\
  w2a =   _mm512_mul_ps(tt1,yy1);\
  w1b =   _mm512_mul_ps(tt2,yy2);\
  w2b =   _mm512_mul_ps(tt2,yy1);\
\
  ff2 = _mm512_load_ps((char *)&(_fp_[3]));                            /* ff2 = (f18i, f3i,f18r, f3r) */\
\
  tt1 = (__m512)_mm512_permute4f128_epi32((__m512i)ff1,_MM_PERM_ABAB); /* tt1 = ( f5r, f9r, f5r, f9r) */\
  tt2 = (__m512)_mm512_permute4f128_epi32((__m512i)ff1,_MM_PERM_BABA); /* tt2 = ( f9r, f5r, f9r, f5r) */\
  w1c = _mm512_fmadd_ps(tt1,yy2,w1c);\
  w2c =   _mm512_mul_ps(tt2,yy1);\
\
  tt1 = (__m512)_mm512_permute4f128_epi32((__m512i)ff1,_MM_PERM_CDCD); /* tt1 = ( f5i, f9i, f5i, f9i) */\
  tt2 = (__m512)_mm512_permute4f128_epi32((__m512i)ff1,_MM_PERM_DCDC); /* tt2 = ( f9i, f5i, f9i, f5i) */\
  w1d = _mm512_fmadd_ps(tt1,yy2,w1d);\
  w2d =   _mm512_mul_ps(tt2,yy1);\
\
  ff1 = _mm512_load_ps((char *)&(_fp_[4]));                            /* ff1 = (f13i, f6i,f13r, f6r) */\
\
  tt1 = (__m512)_mm512_permute4f128_epi32((__m512i)ff2,_MM_PERM_BABA); /* tt1 = (f18r, f3r,f18r, f3r) */\
  tt2 = (__m512)_mm512_permute4f128_epi32((__m512i)ff2,_MM_PERM_DCDC); /* tt2 = (f18i, f3i,f18i, f3i) */\
  w1a = _mm512_fmadd_ps(tt1,yy3,w1a);\
  w3a =   _mm512_mul_ps(tt1,yy1);\
  w1b = _mm512_fmadd_ps(tt2,yy3,w1b);\
  w3b =   _mm512_mul_ps(tt2,yy1);\
\
  ff2 = _mm512_load_ps((char *)&(_fp_[5]));                            /* ff2 = (f10i,f10r,f19r, f7r) : diagonal block */\
\
  tt1 = (__m512)_mm512_permute4f128_epi32((__m512i)ff1,_MM_PERM_ABAB); /* tt1 = ( f6r,f13r, f6r,f13r) */\
  tt2 = (__m512)_mm512_permute4f128_epi32((__m512i)ff1,_MM_PERM_BABA); /* tt2 = (f13r, f6r,f13r, f6r) */\
  w1c = _mm512_fmadd_ps(tt1,yy3,w1c);\
  w3c =   _mm512_mul_ps(tt2,yy1);\
\
  tt1 = (__m512)_mm512_permute4f128_epi32((__m512i)ff1,_MM_PERM_CDCD); /* tt1 = ( f6i,f13i, f6i,f13i) */\
  tt2 = (__m512)_mm512_permute4f128_epi32((__m512i)ff1,_MM_PERM_DCDC); /* tt2 = (f13i, f6i,f13i, f6i) */\
  w1d = _mm512_fmadd_ps(tt1,yy3,w1d);\
  w3d =   _mm512_mul_ps(tt2,yy1);\
\
  ff1 = _mm512_load_ps((char *)&(_fp_[6]));                            /* ff1 = (f20i, f8i,f20r, f8r) */\
\
  tt1 = (__m512)_mm512_permute4f128_epi32((__m512i)ff2,_MM_PERM_BABA); /* tt1 = (f19r, f7r,f19r, f7r) */\
  tt2 = (__m512)_mm512_permute4f128_epi32((__m512i)ff2,_MM_PERM_CCCC); /* tt2 = (f10r,f10r,f10r,f10r) */\
  tt3 = (__m512)_mm512_permute4f128_epi32((__m512i)ff2,_MM_PERM_DDDD); /* tt3 = (f10i,f10i,f10i,f10i) */\
  w2a = _mm512_fmadd_ps(tt1,yy2,w2a);\
  w2c = _mm512_fmadd_ps(tt2,yy2,w2c);\
  w2d = _mm512_fmadd_ps(tt3,yy2,w2d);\
\
  ff2 = _mm512_load_ps((char *)&(_fp_[7]));                            /* ff2 = (f14i,f11i,f14r,f11r) */\
\
  tt1 = (__m512)_mm512_permute4f128_epi32((__m512i)ff1,_MM_PERM_BABA); /* tt1 = (f20r, f8r,f20r, f8r) */\
  tt2 = (__m512)_mm512_permute4f128_epi32((__m512i)ff1,_MM_PERM_DCDC); /* tt2 = (f20i, f8i,f20i, f8i) */\
  w2a = _mm512_fmadd_ps( tt1,yy3,w2a);\
  w3a = _mm512_fmadd_ps( tt1,yy2,w3a);\
  w2b = _mm512_fnmadd_ps(tt2,yy3,w2b); /* w2b = w2b - tt2*yy3 */\
  w3b = _mm512_fmadd_ps( tt2,yy2,w3b);\
\
  ff1 = _mm512_load_ps((char *)&(_fp_[8]));                            /* ff1 = (f15i,f15r,f21r,f12r) : diagonal block */\
\
  tt1 = (__m512)_mm512_permute4f128_epi32((__m512i)ff2,_MM_PERM_ABAB); /* tt1 = (f11r,f14r,f11r,f14r) */\
  tt2 = (__m512)_mm512_permute4f128_epi32((__m512i)ff2,_MM_PERM_BABA); /* tt2 = (f14r,f11r,f14r,f11r) */\
  w2c = _mm512_fmadd_ps(tt1,yy3,w2c);\
  w3c = _mm512_fmadd_ps(tt2,yy2,w3c);\
\
  tt1 = (__m512)_mm512_permute4f128_epi32((__m512i)ff2,_MM_PERM_CDCD); /* tt1 = (f11i,f14i,f11i,f14i) */\
  tt2 = (__m512)_mm512_permute4f128_epi32((__m512i)ff2,_MM_PERM_DCDC); /* tt2 = (f14i,f11i,f14i,f11i) */\
  w2d = _mm512_fmadd_ps(tt1,yy3,w2d);\
  w3d = _mm512_fmadd_ps(tt2,yy2,w3d);\
\
\
  tt1 = (__m512)_mm512_permute4f128_epi32((__m512i)ff1,_MM_PERM_BABA); /* tt1 = (f21r,f12r,f21r,f12r) */\
  tt2 = (__m512)_mm512_permute4f128_epi32((__m512i)ff1,_MM_PERM_CCCC); /* tt2 = (f15r,f15r,f15r,f15r) */\
  tt3 = (__m512)_mm512_permute4f128_epi32((__m512i)ff1,_MM_PERM_DDDD); /* tt3 = (f15i,f15i,f15i,f15i) */\
  w3a = _mm512_fmadd_ps(tt1,yy3,w3a);\
  w3c = _mm512_fmadd_ps(tt2,yy3,w3c);\
  w3d = _mm512_fmadd_ps(tt3,yy3,w3d);\
\
\
  w1b = (__m512)_mm512_permute4f128_epi32((__m512i)w1b,_MM_PERM_BADC);\
  w2b = (__m512)_mm512_permute4f128_epi32((__m512i)w2b,_MM_PERM_BADC);\
  w3b = (__m512)_mm512_permute4f128_epi32((__m512i)w3b,_MM_PERM_BADC);\
\
  w1b = (__m512)_mm512_mask_xor_epi32((__m512i)w1b,0x00FF,(__m512i)w1b,(__m512i)neg);\
  w2b = (__m512)_mm512_mask_xor_epi32((__m512i)w2b,0xFF00,(__m512i)w2b,(__m512i)neg);\
  w3b = (__m512)_mm512_mask_xor_epi32((__m512i)w3b,0xFF00,(__m512i)w3b,(__m512i)neg);\
\
  w1c = (__m512)_mm512_permute4f128_epi32((__m512i)w1c,_MM_PERM_CDAB);\
  w2c = (__m512)_mm512_permute4f128_epi32((__m512i)w2c,_MM_PERM_CDAB);\
  w3c = (__m512)_mm512_permute4f128_epi32((__m512i)w3c,_MM_PERM_CDAB);\
\
  w1d = (__m512)_mm512_permute4f128_epi32((__m512i)w1d,_MM_PERM_ABCD);\
  w2d = (__m512)_mm512_permute4f128_epi32((__m512i)w2d,_MM_PERM_ABCD);\
  w3d = (__m512)_mm512_permute4f128_epi32((__m512i)w3d,_MM_PERM_ABCD);\
\
  w1d = (__m512)_mm512_mask_xor_epi32((__m512i)w1d,0xF00F,(__m512i)w1d,(__m512i)neg);\
  w2d = (__m512)_mm512_mask_xor_epi32((__m512i)w2d,0xF00F,(__m512i)w2d,(__m512i)neg);\
  w3d = (__m512)_mm512_mask_xor_epi32((__m512i)w3d,0xF00F,(__m512i)w3d,(__m512i)neg);\
\
  w1a = _mm512_add_ps(w1a,w1b);\
  w2a = _mm512_add_ps(w2a,w2b);\
  w3a = _mm512_add_ps(w3a,w3b);\
\
  w1c = _mm512_add_ps(w1c,w1d);\
  w2c = _mm512_add_ps(w2c,w2d);\
  w3c = _mm512_add_ps(w3c,w3d);\
\
  _w_ ## 1 = _mm512_add_ps(w1a,w1c);\
  _w_ ## 2 = _mm512_add_ps(w2a,w2c);\
  _w_ ## 3 = _mm512_add_ps(w3a,w3c);\
\
}

#endif

#endif
