template<typename T, int ntmp>
class wqftmp
{
    T *tmps;
    int top;
public:
    wqftmp() : tmps(0), top(0) {}
    ~wqftmp() { _mm_free(tmps); }
    T *push()
    {
        if (tmps == 0)
        {
            tmps = (T *)_mm_malloc(ntmp*sizeof(T),64);
            if (tmps == 0)
            {
                fprintf(stderr, "wqf out of memory\n");
                exit(0);
            }
        }
        if (top >= ntmp)
        {
            fprintf(stderr, "push wqf overflow\n");
            exit(1);
        }
        return &tmps[top++];
    }
    T pop(int n)
    {
        if (n > top)
        {
            fprintf(stderr, "pop wqf underflow\n");
            exit(1);
        }
        top -= n;
    }
};

static wqftmp<mic_wqf_eo, 10> wqf_tmp;
static wqftmp<mic_ras_wqf_eo, 3> ras_wqf_tmp;
